// Telosys build number : 548 - Date : May-18-2006 (18:36) - Version : 0.9.3 
//----------------------------------------------------------------------------------------------------
// fwkCommon.js
//----------------------------------------------------------------------------------------------------
function fwkGetField(sId)
{
	var oField = document.getElementById(sId) ; 
	if ( oField == null )
	{
		alert("ERROR : Cannot found object for id "+sId ) ;
	}
	return oField ;
}
//----------------------------------------------------------------------------------------------------
function fwkSetChecked(sId, bStatus)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		if ( oField.tagName == 'INPUT' && ( oField.type == "checkbox" || oField.type == "radio" ) ) 
		{
			oField.checked = bStatus ;
		}
		else
		{
			alert( "ERROR : " + sId + " is not a checkbox or a radio button ! ") ;
		}
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsChecked(sId)
{
	var oField = fwkGetField(sId) ; 
	if ( oField != null )
	{
		if ( oField.tagName == 'INPUT' && ( oField.type == "checkbox" || oField.type == "radio" ) ) 
		{
			return oField.checked ;
		}
		else
		{
			alert( "ERROR : " + sId + " is not a checkbox or a radio button ! ") ;
		}
	}
	else
	{
		return null  ;
	}
}
//----------------------------------------------------------------------------------------------------
function fwkGetValue(arg)
{
	var oField = null ; 
	if ( typeof arg == "string" )
	{
		//alert ( "C'est une chaine ! \n typeof = " + typeof arg ) ;
		oField = fwkGetField(arg) ; 
	}
	else if ( typeof arg == "object" )
	{
		//alert ( "C'est un objet ! \n typeof = " + typeof arg ) ;
		oField = arg ; 
	}
	else
	{
		alert ( "ERROR : fwkGetValue() invalid argument type ! ( type = " + typeof arg + " )" ) ;
		return null ;
	}
	if ( oField != null )
	{
	/**
		if ( "checked" in oField )
		{
			alert ( "checked attribute found " );
			return ( oField.checked ? "1" : "0" );
		}
		**/
		if ( oField.type == "checkbox" )
		{
			alert ( "checkbox object" );
			return ( oField.checked ? "1" : "0" );
		}
		return oField.value ;
	}
	else
	{
		alert ( "ERROR : Field " + arg + " not found !") ;
		return null  ;
	}
}
//----------------------------------------------------------------------------------------------------
function fwkSetValue(sId,sValue)
{
	var oField = fwkGetField(sId) ; 
	if ( oField != null )
	{
		oField.value = sValue ;
	}
}
//----------------------------------------------------------------------------------------------------
function fwkGetName(sId)
{
	var oField = fwkGetField(sId) ; 
	if ( oField != null )
	{
		return oField.name ;
	}
}
//----------------------------------------------------------------------------------------------------
function fwkGetType(sId)
{
	var oField = fwkGetField(sId) ; 
	if ( oField != null )
	{
		return oField.type ;
	}
}
//----------------------------------------------------------------------------------------------------
// ENABLE / DISABLE 
//----------------------------------------------------------------------------------------------------
function fwkSetFieldButtonDisabled(sId, bDisabled)
{
	var oButton = document.getElementById(sId+"_button");
	if ( oButton != null )
	{
		//alert ( "tagName = " + oButton.tagName + " type = " + oButton.type );
		if ( oButton.tagName == "INPUT" && oButton.type == "button" ) 
		{
			oButton.disabled = bDisabled ;
		}
		else if ( oButton.tagName == "BUTTON" ) 
		{
			oButton.disabled = bDisabled ;
		}
		else if ( oButton.tagName == "IMG" ) 
		{
			if ( bDisabled )
			{
				oButton.style.visibility = "hidden" ;
			}
			else
			{
				oButton.style.visibility = "visible" ;
			}
		}
	}		
}
//----------------------------------------------------------------------------------------------------
function fwkEnable(sId)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		oField.disabled = false ;
		fwkSetFieldButtonDisabled(sId, false);
	}
}
//----------------------------------------------------------------------------------------------------
function fwkDisable(sId)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		oField.disabled = true ;
		fwkSetFieldButtonDisabled(sId, true);
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsEnabled(sId)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		if ( oField.disabled != true ) return true ;
	}
	return false ;
}
//----------------------------------------------------------------------------------------------------
// VISIBILITY 
//----------------------------------------------------------------------------------------------------
function fwkSetFieldButtonVisibility(sId, sVisibility)
{
	var oButton = document.getElementById(sId+"_button");
	if ( oButton != null )
	{
		//alert ( "tagName = " + oButton.tagName + " type = " + oButton.type );
		if ( oButton.tagName == "INPUT" && oButton.type == "button" ) 
		{
			oButton.style.visibility = sVisibility ;
		}
		else if ( oButton.tagName == "BUTTON" ) 
		{
			oButton.style.visibility = sVisibility ;
		}
		else if ( oButton.tagName == "IMG" ) 
		{
			oButton.style.visibility = sVisibility ;
		}
	}		
}
//----------------------------------------------------------------------------------------------------
function fwkSetVisible(sId)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		oField.style.visibility = "visible" ;
		fwkSetFieldButtonVisibility(sId, "visible");
	}
	return false ;
}
//----------------------------------------------------------------------------------------------------
function fwkSetHidden(sId)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		oField.style.visibility = "hidden" ;
		fwkSetFieldButtonVisibility(sId, "hidden");
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsVisible(sId)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		if ( oField.style.visibility == "visible" ) return true ;
	}
	return false ;
}

//----------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------
function RadioGroupGetValue(sName)
{
	var radioButtons = document.getElementsByName(sName) ; 
	if ( radioButtons != null )
	{
		for ( var i=0 ; i < radioButtons.length ; i++ )
		{
			if ( radioButtons[i].type == "radio" )
			{
				// alert ( "Id : " + radioButtons[i].id + " => VALUE = " + radioButtons[i].value )  ;
				if ( radioButtons[i].checked ) return radioButtons[i].value ;
			}
		}
		// Aucun bouton slectionn 
		return null ;
	}
	else
	{
		alert("Cannot found Radio Buttons Group for name "+sName ) ;
	}
}
//----------------------------------------------------------------------------------------------------
function RadioGroupSetValue(sName, sValue)
{
	var radioButtons = document.getElementsByName(sName) ; 
	if ( radioButtons != null )
	{
		for ( var i=0 ; i < radioButtons.length ; i++ )
		{
			if ( radioButtons[i].type == "radio" )
			{
				// alert ( "Id : " + radioButtons[i].id + " => VALUE = " + radioButtons[i].value )  ;
				//if ( radioButtons[i].checked ) return radioButtons[i].value ;
				if ( radioButtons[i].value == sValue ) 
				{
					radioButtons[i].checked = true  ;
				}
				else
				{
					radioButtons[i].checked = false  ;
				}
			}
		}
	}
	else
	{
		alert("Cannot found Radio Buttons Group for name "+sName ) ;
	}
}
//----------------------------------------------------------------------------------------------------
function showSelectedValue(sName)
{
	alert ( "Radio Group "+ sName + " : \nSELECTED VALUE = " + RadioGroupGetValue(sName) );
}
//----------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// fwkTools.js  
// Tools class : a set of static methods 
//------------------------------------------------------------------------------
// Version : 1.0 ( 25/10/2005 )
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
function Tools()
{
}
//------------------------------------------------------------------------------
Tools.xmlString = function (sVal)
{
	if ( sVal == null )
	{
		return null ;
	}
	var sXml = sVal ;
	sXml = sXml.replace(/&/g, "&amp;" ); // A faire en premier 
	sXml = sXml.replace(/</g, "&lt;" );
 		sXml = sXml.replace(/>/g, "&gt;" );
	sXml = sXml.replace(/\"/g, "&quot;" );
	/**
	if ( sVal.length != sXml.length )
	{
		alert ( "xmlString : [" + sVal + "] --> [" + sXml + "]" );
	}
	**/
	return sXml ;
}
//------------------------------------------------------------------------------
Tools.getElement = function ( arg )
{
	return element ;
}
//------------------------------------------------------------------------------
// Return the position (X,Y) of an element of the current document
// arg    : String => element Id 
//          Other  => element itself
// return : array ( [0] -> x , [1] -> y )
Tools.getPosition = function ( arg )
{
	var oElement = null ;
	if ( typeof arg == "string" )
	{
		//alert ( "Trace: arg is a String => getElementById ('" + arg + "')" );
		oElement = document.getElementById(arg);
		if ( oElement == null )
		{
			alert ( "Error: Tools.getPosition() : Cannot find element with id = '" + arg + "'" );
			return null ;
		}
	}
	else
	{
		//alert ( "Trace: arg is not a String => ref" );
		oElement = arg;
		if ( oElement == null )
		{
			alert ( "Error: Tools.getPosition() : Element is null ! " );
			return null ;
		}
	}
	
	if ( oElement.offsetParent ) 
	{
		for( var posX = 0, posY = 0; oElement.offsetParent ; oElement = oElement.offsetParent ) 
		{
			posX += oElement.offsetLeft;
			posY += oElement.offsetTop;
		}
		return [ posX, posY ];
	} 
	else 
	{
		return [ oElement.x, oElement.y ];
	}
}
//------------------------------------------------------------------------------
Tools.fieldMessageClass = null ;
Tools.fieldMessageXOffset = null ;
Tools.fieldMessageYOffset = null ;
Tools.setFieldMessageClass = function ( sClassName )
{
	Tools.fieldMessageClass = sClassName ;
}
Tools.setFieldMessageOffset = function ( iXOffset, iYOffset )
{
	Tools.fieldMessageXOffset = iXOffset ;
	Tools.fieldMessageYOffset = iYOffset ;
}
//------------------------------------------------------------------------------
Tools.fieldMessage = function (id, msg)
{
	function _onClick()
	{
		//alert("On Click ! this.id = "  + this.id );
		this.style.visibility = "hidden" ;
	}
	
	var position = Tools.getPosition(id); // (X,Y)
	if ( position != null )
	{
		var x = position[0];
		var y = position[1];
		//alert ( "Position : x = " + x + " , y = " + y );
		
		var sBubbleId = id + "_msg" ;
		var oBubble = document.getElementById(sBubbleId);
		if ( oBubble == null ) // Not yet created 
		{
			//alert ( "oBubble == null => createElement" );
			oBubble = document.createElement ( "table" ) ; 
			oBubble.id = sBubbleId ;
			//oBubble.className = "bubble" ;
			if ( Tools.fieldMessageClass != null )
			{
				// Apply style class
				oBubble.className = Tools.fieldMessageClass ;
			}
			else
			{
				// Use default style
				oBubble.style.cursor      = "default" ;
				oBubble.style.borderStyle = "solid" ;
				oBubble.style.borderWidth = "1px" ;
				oBubble.style.borderColor = "orange" ;
				oBubble.style.color       = "navy" ; 
				oBubble.style.fontFamily  = "arial" ;
				oBubble.style.fontSize    = "10pt" ;
				oBubble.style.backgroundColor = "#FFCC66" ;
			}
			oBubble.style.position   = "absolute" ;
			oBubble.style.visibility = "hidden" ;
			oBubble.onclick = _onClick ;
			document.body.appendChild(oBubble);
			//--- Create Row (TR) and Cell (TD)
			var oTR = oBubble.insertRow(0);
			var oTD = oTR.insertCell(0);
		}
		if ( oBubble != null )  
		{
			//alert ( "oBubble != null => set attributes ..." );
			var oTD = oBubble.rows[0].cells[0];
			if ( oTD != null )
			{
				oTD.innerHTML = msg ;
			}
			else
			{
				alert("Error: Cannot find cell ( table.rows[0].cells[0] )" );
			}
			var xOffset = ( Tools.fieldMessageXOffset != null ? Tools.fieldMessageXOffset : 10 ) ;
			var yOffset = ( Tools.fieldMessageYOffset != null ? Tools.fieldMessageYOffset : 12 ) ;
			oBubble.style.left       = x + xOffset ;
			oBubble.style.top        = y + yOffset ;
			oBubble.style.visibility = "visible" ;
		}
		else
		{
			alert ( "Error: Cannot get or create bubble DIV !" ) ;
		}
	}
	else
	{
		alert("Error: Cannot find position for id '" + id + "' !");
	}
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Ancestor.js
//------------------------------------------------------------------------------
// Version : 1.0  ( 22/03/2005 )
// Author  : Laurent Gurin 
// Changes : . Creation
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION 
//------------------------------------------------------------------------------
function Ancestor( sClassName, bTraceFlag )
{
	//==============================================================================
	// STANDARD ATTRIBUTES & METHODS
	//==============================================================================
	var _sClassName = sClassName ;
	var _bTrace = false ;
	//--- If there is a TraceFlag parameter => use it
	if ( bTraceFlag != null )
	{
		_bTrace = bTraceFlag ;
	}
	
	//------------------------------------------------------------------------------
	this.trace = function ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE : [" + _sClassName + "] \n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	this.error = function ( sMsg ) 
	{
		alert ( "ERROR : [" + _sClassName + "] \n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	this.getClassName = function() 
	{
		return _sClassName ;
	}
	//------------------------------------------------------------------------------
	this.getTrace = function() 
	{
		return _bTrace ;
	}
	//------------------------------------------------------------------------------
	this.setTrace = function( bFlag ) 
	{
		_bTrace = bFlag ;
	}
	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------
//                                 THE END
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// AjaxRequester.js
//------------------------------------------------------------------------------
// Version : 1.0  ( 22/03/2005 )
// Author  : Laurent Gurin 
// Changes : . Creation
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION 
//------------------------------------------------------------------------------
function AjaxRequester( sDefaultUrlParam )
{
	//--- Call the super constructor
	Ancestor.call(this, "AjaxRequester", false);
	var _this = this ;
	var _trace = this.trace ;
	var _error = this.error ;
	//------------------------------------------------------------------------------

	//------------------------------------------------------------------------------
	// PRIVATE ATTRIBUTES
	//------------------------------------------------------------------------------	
	var _sDefaultUrl         = null ;
	var _oXMLHTTP            = null ; // THE "XMLHttpRequest" object
	var _sRequestContent     = null ; // The last request content
	var _oScreenResponse     = null ; // The last response object
	var _fctProcessResponse  = null ; // External function to process the response
	
	if ( sDefaultUrlParam != null )
	{
		_sDefaultUrl = sDefaultUrlParam ;
	}
	
	//--- Instance init 	
    if (window.ActiveXObject) 
	{
    	//--- Internet Explorer
    	_oXMLHTTP = new ActiveXObject("Microsoft.XMLHTTP");
    }
    else if (window.XMLHttpRequest)
    {
    	//--- Mozilla & Safari
    	_oXMLHTTP = new XMLHttpRequest();
    }

	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================

	//------------------------------------------------------------------------------
	// AJAX response processing : build the response and call the callBackFunction 
	//------------------------------------------------------------------------------
	function _processAjaxResponse() // Called for each state change (1,2,3 & 4)
	{
		//_trace("_processAjaxResponse() : readyState = " + _oXMLHTTP.readyState );
		//--- If new state is "COMPLETE" ...
		if ( _oXMLHTTP.readyState == 4 )
		{
			_trace("_processAjaxResponse() : Response received : \n" + _oXMLHTTP.responseText );
			//--- Build the ScreenResponse object
			_trace("_processAjaxResponse() : Build the ScreenResponse object ..." );
			_oScreenResponse = new ScreenResponse(_oXMLHTTP);
			//--- Run the callback if it exists
			if ( _fctProcessResponse != null )
			{
				_trace("_processAjaxResponse() : Run callback function ..." );
				_fctProcessResponse(_oScreenResponse) ;
			}
		}
	}
	//------------------------------------------------------------------------------
	// Send HttpRequest to the server 
	//------------------------------------------------------------------------------
	function _sendRequest ( sHttpMethod, sURL, bAsync, sContent, processResponseFunction) // RET : void 
	{
		if ( sHttpMethod == null )
		{
			_error ( "_sendRequest() : HTTP Method is null ! " ); 
			return ;
		}
		if ( sURL == null ) // Use default URL
		{
			sURL = _sDefaultUrl ;
		}
		if ( sURL == null )  // URL still null ? 
		{
			_error ( "_sendRequest() : URL is null ! " ); 
			return ;
		}
		if ( processResponseFunction == null )
		{
			_error ("_sendRequest() : processResponse function is NULL !");
			return ;
		}
		
		if ( _oXMLHTTP == null )
    	{
			_error ( "_sendRequest() : XMLHttpRequest object is null !" );
			return ;
    	}

		_sRequestContent = sContent ;
		_fctProcessResponse = processResponseFunction ;
		
	    _trace( "_sendRequest("+sHttpMethod+","+sURL+","+bAsync+",..,..) : \nContent :\n" + _sRequestContent ); // Show the request 

		//--- (1) Setup the HTTP Request Method and URL 
	    _oXMLHTTP.open (sHttpMethod, sURL, bAsync);  // false = SYNCHRONOUS  (true = ASYNCHRONOUS)	    
		if ( sContent != null )
		{
		    _oXMLHTTP.setRequestHeader("Content-Type", "text/xml");
		}

		//--- (2) Configure the callback method (if ASYNCHRONOUS) 
	    if ( bAsync )
	    {
			_oXMLHTTP.onreadystatechange = _processAjaxResponse ;
		}

		//--- (3) Send the request to the server 
	    _oXMLHTTP.send (sContent); // Send the content (via HTTP)
	    
	    //--- (4) if this request is not ASYNCHRONOUS => call the method to process the response
	    if ( ! bAsync )
	    {
			_processAjaxResponse() ;
		}
	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================

	//------------------------------------------------------------------------------
	// Get the last request content (request body)
	//------------------------------------------------------------------------------
	this.getRequest = function() 
	{
		return _sRequestContent ;
	}
	//------------------------------------------------------------------------------
	// Get the Screen Response object
	//------------------------------------------------------------------------------
	this.getResponse = function() 
	{
		return _oScreenResponse ;
	}

	//------------------------------------------------------------------------------
	// SYNCHRONOUS "GET"
	//------------------------------------------------------------------------------
	this.getSync = function ( sUrl, sContent, processResponseFunction )
	{
		_trace ("getSync(" + sUrl + ", .., ..)" );
		_sendRequest("GET", sUrl, false, sContent, processResponseFunction);
	}
	//------------------------------------------------------------------------------
	// ASYNCHRONOUS "GET"
	//------------------------------------------------------------------------------
	this.getAsync = function ( sUrl, sContent, processResponseFunction )
	{
		_trace ("getAsync(" + sUrl + ", .., ..)" );
		_sendRequest("GET", sUrl, true, sContent, processResponseFunction);
	}
	
	//------------------------------------------------------------------------------
	// SYNCHRONOUS "POST"
	//------------------------------------------------------------------------------
	this.postSync = function ( sUrl, sContent, processResponseFunction )
	{
		_trace ("postSync(" + sUrl + ", .., ..)" );
		_sendRequest("POST", sUrl, false, sContent, processResponseFunction);
	}
	//------------------------------------------------------------------------------
	// ASYNCHRONOUS "POST"
	//------------------------------------------------------------------------------
	this.postAsync = function ( sUrl, sContent, processResponseFunction )
	{
		_trace ("postAsync(" + sUrl + ", .., ..)" );
		_sendRequest("POST", sUrl, true, sContent, processResponseFunction);
	}
	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// fwkBrowser.js 
//------------------------------------------------------------------------------
// Version : 1.0 ( 26/10/2005 )
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
function Browser()
{
	//------------------------------------------------------------------------------
	// CONSTANTS
	//------------------------------------------------------------------------------
	this.NAV_NULL = 0 ;
	this.NAV_MOZILLA_FIREFOX   = 1 ; 
	this.NAV_INTERNET_EXPLORER = 2 ;

	//------------------------------------------------------------------------------
	// ATTRIBUTES
	//------------------------------------------------------------------------------
	this.iBrowserType = this.NAV_NULL ;
	
	
	//------------------------------------------------------------------------------
	// INITIALIZATIONS
	//------------------------------------------------------------------------------
	{
		//var sNavigName = navigator.appName ;
		if ( navigator.appName.indexOf("Netscape") >= 0 )
		{
			this.iBrowserType = this.NAV_MOZILLA_FIREFOX ;
		}
		else if ( navigator.appName.indexOf("Microsoft") >= 0 )
		{
			this.iBrowserType = this.NAV_INTERNET_EXPLORER ;
		}
	}

	//------------------------------------------------------------------------------
	// METHODS
	//------------------------------------------------------------------------------
	this.isMozilla = function() // BOOLEAN
	{
		return ( this.iBrowserType == this.NAV_MOZILLA_FIREFOX ? true : false ) ;
	}
	//------------------------------------------------------------------------------
	this.isInternetExplorer = function() // BOOLEAN
	{
		return ( this.iBrowserType == this.NAV_INTERNET_EXPLORER ? true : false ) ;
	}
	//------------------------------------------------------------------------------
	this.getType = function() // STRING
	{
		switch ( this.iBrowserType )
		{
			case this.NAV_MOZILLA_FIREFOX :   return "Mozilla/Firefox" ;
			case this.NAV_INTERNET_EXPLORER : return "Internet Explorer" ;
		}
		return "???" ;
	}
	
}
//------------------------------------------------------------------------------
// Static properties
//------------------------------------------------------------------------------
Browser.browser = new Browser() ; 
//------------------------------------------------------------------------------
// Static methods
//------------------------------------------------------------------------------
Browser.getBrowser = function ()
{
	return Browser.browser ;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// fwkKeyboard.js 
// Keyborad class : keyboard management
//------------------------------------------------------------------------------
// Uses : Browser class
//------------------------------------------------------------------------------
// Version : 1.0 ( 26/10/2005 )
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------
// Mozilla/Firefox behavior :
// Standard Keys : 1) onKeyPress + 2) onKeyDown ( no order ?,  2 distinct events )
// Fct Keys      : 1) onKeyDown + 2) onKeyPress ( F1..F12, Esc, Tab, Arrows, End, Home, Del )
// CAPS, Ctrl, Alt : onKeyDown ( NO onKeyPress )
//------------------------------------------------------------------------------
// Internet Explorer behavior :
// Standard Keys : onKeyPress ONLY ( NO onKeyDown )
// Fct Keys      : onKeyDown  ONLY ( NO onKeyPress ) ( F1..F12, Tab, )
// ESC Key       : 1) onKeyDown + 2) onKeyPress
// CAPS, Ctrl, Alt, Arrows, End, Home, Del : onKeyDown ( NO onKeyPress )
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
function KeyAction(oFct, iType, bStop)
{
	this.oFunction = oFct ;
	this.iEvtType  = iType ;
	this.bStop     = bStop ;
}

//------------------------------------------------------------------------------
// STATIC CONSTANTS
//------------------------------------------------------------------------------
Keyboard.EVT_KEY_PRESS = 1 ;
Keyboard.EVT_KEY_DOWN  = 2 ;

Keyboard.KEY_ESC = 27 ;
Keyboard.KEY_F1  = 112 ;
Keyboard.KEY_F2  = 113 ;
Keyboard.KEY_F3  = 114 ;
Keyboard.KEY_F4  = 115 ;
Keyboard.KEY_F5  = 116 ;
Keyboard.KEY_F6  = 117 ;
Keyboard.KEY_F7  = 118 ;
Keyboard.KEY_F8  = 119 ;
Keyboard.KEY_F9  = 120 ;
Keyboard.KEY_F10 = 121 ;
Keyboard.KEY_F11 = 122 ;
Keyboard.KEY_F12 = 123 ;

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
function Keyboard()
{
	//------------------------------------------------------------------------------
	// CONSTANTS
	//------------------------------------------------------------------------------

	//------------------------------------------------------------------------------
	// ATTRIBUTES
	//------------------------------------------------------------------------------
	//this.browser = Browser.getBrowser();
	this.aKeyActions = new Array();
	//------------------------------------------------------------------------------
	// METHODS
	//------------------------------------------------------------------------------
	this.desc = function()
	{
		//return ( "keyboard object for browser " + this.browser.getType() ) ;
		return ( "keyboard object : " + this.aKeyActions + " key(s) mapped") ;
	}
	//------------------------------------------------------------------------------
	this.setKeyAction = function( iKey, oFunction, iEventType )
	{
		//alert ( "setKeyAction : key = " + iKey ) ;
		if ( iKey      == null ) alert ( "ERROR: keyAction() : KEY parameter is null !" );
		if ( oFunction == null ) 
		{
			this.aKeyActions[iKey] = new KeyAction ( null, iEventType, true );
		}
		else
		{		
			if ( ! oFunction instanceof Function ) 
			{
				alert ( "ERROR: keyAction() : ACTION is not a function !" );
			}
			this.aKeyActions[iKey] = new KeyAction ( oFunction, iEventType, true );
		}
	}
	//------------------------------------------------------------------------------
	this.getNbKeyActions = function() // INT
	{
		return this.aKeyActions.length ;
	}
	//------------------------------------------------------------------------------
	this.showKeyActions = function() // VOID
	{
		var s = "Key Actions : \n" ;
		for ( var elt in this.aKeyActions )
		{
			s += elt + " -> " + this.aKeyActions[elt] + "\n" ;
		}
		alert(s);
	}
	//------------------------------------------------------------------------------
	this.keyPress = function(evt)
	{
		//alert ( " keyPress " );
		if ( window.event )
		{
			//iKeyCode = event.keyCode ;
			this.processKeyCode(window.event.keyCode, Keyboard.EVT_KEY_PRESS );
		}
		else
		{
			if ( evt ) // Mozilla - Firefox 
			{
				this.processKeyCode(evt.keyCode, Keyboard.EVT_KEY_PRESS, evt);
			}
		}
	}
	//------------------------------------------------------------------------------
	this.keyDown = function(evt)
	{
		//alert ( " keyDown " );
		if ( window.event )
		{
			this.processKeyCode(window.event.keyCode, Keyboard.EVT_KEY_DOWN );
		}
		else
		{
			if ( evt ) // Mozilla - Firefox 
			{
				this.processKeyCode(evt.keyCode, Keyboard.EVT_KEY_DOWN, evt);
			}
		}
		return false ;
	}
	//------------------------------------------------------------------------------
	this.processKeyCode = function(iKeyCode, iEvtType, evt )
	{
		//alert("processKeyCode("+iKeyCode+","+iEvtType+")"  );
		//--- Is there an action associated with this KeyCode ?
		var oAction = this.aKeyActions[iKeyCode] ;
		if ( oAction != null )
		{
			//--- 1) STOP PROPAGATION
			if ( window.event )
			{
			    window.event.cancelBubble = true;
			    window.event.returnValue  = false;
			    window.event.keyCode      = -1 ;
			}
			else
			{
				if ( evt ) // Mozilla - Firefox 
				{
				    evt.stopPropagation();
				    evt.preventDefault();
				    // evt.preventBubble(); // Sans effet
				    // evt.cancelBubble = true ; // Sans effet
				    //evt.keyCode = 0 ; // Impossible (Read-Only)
				}
			}
			//--- 2) CALL THE ACTION FUNCTION
			if ( oAction.iEvtType == iEvtType )
			{
				if ( oAction.oFunction != null )
				{
					oAction.oFunction();
				}
			}
		}
	/***
		else
		{
			alert ( "No specific action for the key " + iKeyCode ) ;
		}
	***/
		//alert("END OF processKeyCode("+iKeyCode+") evt.processed = " + evt.processed );
	}
	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------
// Static properties
//------------------------------------------------------------------------------
Keyboard.keyboard = new Keyboard() ; 
//------------------------------------------------------------------------------
// Static methods
//------------------------------------------------------------------------------
Keyboard.getKeyboard = function ()
{
	return Keyboard.keyboard ;
}
//------------------------------------------------------------------------------
Keyboard.onKeyPress = function (evt)
{
	//alert ( "Keyboard.onKeyPress " );
	Keyboard.keyboard.keyPress(evt) ;
	//return false ;
}
//------------------------------------------------------------------------------
Keyboard.onKeyDown = function (evt)
{
	//alert ( "Keyboard.onKeyDown " );
	Keyboard.keyboard.keyDown(evt) ;
	//return false ;
}
//------------------------------------------------------------------------------
Keyboard.onHelp = function () // Method to catch the IE "onHelp" event ( F1 key )
{
	window.event.returnValue = false;
	alert("fwkOnHelp");
}
//------------------------------------------------------------------------------
// METHODE : Permet de catcher l'vnement standard sur la touche 'F1'
/**
function document.onhelp()
{
	window.event.returnValue = false;
}
**/		
//------------------------------------------------------------------------------
{
	var browser = Browser.getBrowser() ;
	if ( browser.isInternetExplorer() )
	{
		//alert ( "Keyboard Config for IE" ) ;
		document.onhelp = Keyboard.onHelp ;
		// Only the KeyDown is used 
		document.onkeydown = Keyboard.onKeyDown ;
	}
	if ( browser.isMozilla() )
	{
		//alert ( "Keyboard Config for Mozilla" ) ;
		document.onkeydown  = Keyboard.onKeyDown ;
		document.onkeypress = Keyboard.onKeyPress ;	
		//document.onkeypress = Keyboard.keyboard.keyPress ; // NOT OK ( the instance method doesn't access attributes !) 
	}
}

//------------------------------------------------------------------------------
// fwkSimpleDate.js
//------------------------------------------------------------------------------
// Version : 1.0  ( 12/12/2005 )
// Author  : Laurent Gurin 
// Changes : none (creation)
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function SimpleDate( sDate, sFormat )
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _bTrace  = false ;
	
	//--- Date Value  ( 0 => Date Value is NULL )
	var _iDay     = 0 ; 
	var _iMonth   = 0 ; 
	var _iYear    = 0 ; 
	
	//--- Date Format
	var _sFormat      = null ;
	var _parsedFormat = null ;
	
	try {
		if ( sFormat == null )
		{
			sFormat = "YYYY-MM-DD" ; // ISO format
		}
		//--- Build the Date Value
		_buildDate( sDate, sFormat ) ;
	} 
	catch (ex) {
		alert ( "SimpleDate(" + sDate + "," + sFormat + ") : ERROR : " + ex.message );
	}
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE : \n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	function _setNull() 
	{
		_iDay     = 0 ; 
		_iMonth   = 0 ; 
		_iYear    = 0 ; 
	}
	//------------------------------------------------------------------------------
	function _parseFormat( sFormat ) // throws Error
	{
		//--- Check format length 
		if ( sFormat.length != 6 && sFormat.length != 8 && sFormat.length != 10 )
		{
			throw new Error ( "Invalid date format " + sFormat + " : length != 8 and != 10 " ); 
		}
		var sFormatUC = sFormat.toUpperCase();
		
		//--- Separator identification 
		var sSep = null ;
		var iNbSep = 0 ;
		for ( var i = 0 ; i < sFormatUC.length ; i++ ) 
		{
			c = sFormatUC.charAt(i) ;
			if ( c != 'D' && c != 'M' && c != 'Y'  )  // separator
			{
				//alert ( "Separator = " + c ) ;
				if ( sSep != null && sSep != c )
				{
					// 2 different separators => error 
					throw new Error ( "Invalid date format " + sFormat + " : different separators " ); 
				}
				sSep = c ;
				iNbSep++ ;
			}
		}

		//--- Split format parts ( "DD", "MM" and "YY" or "YYYY" ) 
		var arrayFormat = null ;
		if ( iNbSep == 2 ) // 2 separators
		{
			//--- Split the format in 3 parts 
			arrayFormat = sFormatUC.split(sSep);
			if ( arrayFormat.length != 3 )
			{
				throw new Error ( "Invalid date format " + sFormat + " : " + arrayFormat.length + " parts !" ); 
			}
		}
		else if ( iNbSep == 0 ) // No separators
		{
			arrayFormat = new Array(3) ;
			if ( sFormatUC.length == 6 ) //  2c + 2c + 2c 
			{
				arrayFormat[0] = sFormatUC.substr(0,2);
				arrayFormat[1] = sFormatUC.substr(2,2);
				arrayFormat[2] = sFormatUC.substr(4,2);				
			}
			else if ( sFormatUC.length == 8 )
			{
				var iYYYY = sFormatUC.indexOf("YYYY") ;
				if ( iYYYY == 0 ) // Format starts with "YYYY" ( "YYYY...." )
				{
					arrayFormat[0] = sFormatUC.substr(0,4);
					arrayFormat[1] = sFormatUC.substr(4,2);
					arrayFormat[2] = sFormatUC.substr(6,2);									
				}
				else if ( iYYYY == 2 ) // "YYYY" in the middle ( "..YYYY.." )
				{
					arrayFormat[0] = sFormatUC.substr(0,2);
					arrayFormat[1] = sFormatUC.substr(2,4);
					arrayFormat[2] = sFormatUC.substr(6,2);									
				}
				else if ( iYYYY == 4 ) // "YYYY" at the end ( "....YYYY" )
				{
					arrayFormat[0] = sFormatUC.substr(0,2);
					arrayFormat[1] = sFormatUC.substr(2,2);
					arrayFormat[2] = sFormatUC.substr(4,4);									
				}
				else
				{
					throw new Error ( "Invalid date format " + sFormat + " : length = 8 and YYYY not found " ); 
				}
			}
			else
			{
				throw new Error ( "Invalid date format " + sFormat + " : length != 6 and != 8 " ); 
			}
		}
		else
		{
			throw new Error ( "Invalid date format " + sFormat + " : number of separators != 2 " ); 
		}
		
		//--- Check format parts ( "DD", "MM" and "YY" or "YYYY" ) 
		for ( var x=0 ; x < 3 ; x++ )
		{
			var sPart = arrayFormat[x];
			if ( sPart != "DD" && sPart != "MM" && sPart != "YY" && sPart != "YYYY" )
			{
				throw new Error ( "Invalid date format " + sFormat + " : invalid part " + sPart ); 
			}
		}
		
		var parsedFormat = arrayFormat ;
		parsedFormat[3] = sSep ;
		return parsedFormat ;
	}
	//------------------------------------------------------------------------------
	function _parseDate( sDate, parsedFormat ) 
	{
		var sSep = parsedFormat[3] ;
		var parsedDate = null ;
		if ( sSep != null )
		{
			//--- Split the date with the format separator
			parsedDate = sDate.split(sSep);
		}
		else
		{
			//--- Split the date with the format parts 
			parsedDate = new Array(3) ;
			var iStart = 0 ;
			for ( var i=0 ; i < 3 ; i++ )
			{
				var iSize = parsedFormat[i].length ;
				parsedDate[i] = sDate.substr(iStart, iSize ) ;
				iStart = iStart + iSize ;
			}
		}
		return parsedDate ;
	}
	//------------------------------------------------------------------------------
	function _buildDate( sDate, sFormat ) 
	{
		//alert("_buildDate(" + sDate + "," + sFormat + ")" );
		
		var parsedFormat = _parseFormat(sFormat);  // throws Error	

		//--- Keep the format in the instance (original and parsed)
		_sFormat      = sFormat ;
		_parsedFormat = parsedFormat ;

		//--- Build the Date Value
		if ( sDate == null )
		{
			//--- No date value
			_setNull(); 
		}
		else
		{
			_buildDateWithParsedFormat( sDate, parsedFormat );
		}

	}
	//------------------------------------------------------------------------------	
	function _buildDateWithParsedFormat( sDate, parsedFormat )
	{
		var parsedDate   = _parseDate  (sDate, parsedFormat);
		//alert("_buildDateWithParsedFormat : " + sDate + "\n parsedDate = " + parsedDate + "\n parsedFormat = " + parsedFormat );
		
		//--- Get Integer Values for date parts ( Day, Month, Year )
		var iDay   = 0 ;
		var iMonth = 0 ;
		var iYear  = 0 ;
		for ( var i=0 ; i < 3 ; i++ )
		{
			     if ( parsedFormat[i] == "DD" ) iDay   = parseInt( parsedDate[i],10) ;
			else if ( parsedFormat[i] == "MM" ) iMonth = parseInt( parsedDate[i],10) ;
			else if ( parsedFormat[i] == "YY" || parsedFormat[i] == "YYYY" ) 
			{
				iYear  = parseInt(parsedDate[i],10) ;
				if ( iYear < 100 ) iYear = iYear + 2000 ;
			}
		}
		
		//--- If the date parts are valid 
		if ( _isValid( iYear, iMonth, iDay ) )
		{
			//--- Set instance attributes : Day, Month, Year
			_iYear  = iYear ;
			_iMonth = iMonth ;
			_iDay   = iDay ;
		}
		else
		{
			throw new Error ( "Invalid date : " + sDate );
		}
	}
	//------------------------------------------------------------------------------
	function _isValid( iYear, iMonth, iDay ) // boolean
	{
		var aDaysByMonth = new Array(0,31,28,31,30,31,30,31,31,30,31,30,31);
		//--- If lap year, february is one day longer
		if ( ( iYear % 4 == 0 && iYear % 100 != 0 ) || iYear % 400 == 0 )  
		{
			aDaysByMonth[2] = 29  ; // 29 days for February
		}
		if ( ( iYear  < 0 ) || ( iYear  > 9999 ) )  return false ;
		if ( ( iMonth < 1 ) || ( iMonth > 12 ) )  return false ;
		if ( ( iDay   < 1 ) || ( iDay   > aDaysByMonth[iMonth] ) )  return false ;
		//--- OK   
		return true ;		
	}
	//------------------------------------------------------------------------------
	function _format( parsedFormat )  // throws Error
	{
		//alert( "_format( " + parsedFormat + ")" );
		var sFormatedDate = "" ;
		var sSeparator = parsedFormat[3] ;
		if ( sSeparator == null ) sSeparator = "" ;
		//--- For each part of the format ( Day, Month, Year ) ... 
		var sDatePart   = "" ;
		var sFormatPart = null ;
		for ( var i=0 ; i < 3 ; i++ )
		{
			//alert( "_format() i = " + i );
			if ( i > 0 ) 
			{
				sFormatedDate += sSeparator ;
			}
			sFormatPart = parsedFormat[i] ;
			     if ( sFormatPart.charAt(0) == 'Y' ) sDatePart = ""+_iYear ;
			else if ( sFormatPart.charAt(0) == 'M' ) sDatePart = ""+_iMonth ;
			else if ( sFormatPart.charAt(0) == 'D' ) sDatePart = ""+_iDay ; 
			else throw new Error ( "Invalid format : part = " + sFormatPart );
			if ( sDatePart.length < sFormatPart.length )
			{
				var iDelta = sFormatPart.length - sDatePart.length ;
				     if ( iDelta == 1 ) sDatePart = "0"+sDatePart ;
				else if ( iDelta == 2 ) sDatePart = "00"+sDatePart ;
				else if ( iDelta == 3 ) sDatePart = "000"+sDatePart ;
				else throw new Error ( "Invalid format : part = " + sFormatPart + " invalid length "); 
			}
			sFormatedDate += sDatePart ;
		}
		return sFormatedDate ;
	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.toString = function () 
	{
		return "day=" + _iDay + " month=" + _iMonth + " year=" + _iYear + " (format=" + _sFormat + ")" ;
	}
	//------------------------------------------------------------------------------
	this.show = function () 
	{
		alert("Date Value : day = " + _iDay + " month = " + _iMonth + " year = " + _iYear
			+ ( this.isNull() ? " ( NULL ) " : "" )
		    + "\nFormat : " + _sFormat 
		    + "\nParsed Format : " + _parsedFormat 
		    ) ;
	}
	//------------------------------------------------------------------------------
	// sFormat can be null (use the initial format )
	this.format = function ( sFormat ) // throws Error
	{
		//alert( "format() : Date = " + this.toString() );
		if ( this.isNull() )
		{
			return null ;
		}
		else
		{
			var sFormatedDate = null ;
			//try {
				var parsedFormat = _parsedFormat ;
				if ( sFormat != null )
				{
					parsedFormat = _parseFormat( sFormat ) ;
				}
				sFormatedDate = _format ( parsedFormat );
			/**
			}
			catch ( ex ) {
				alert ( "ERROR : \nSimpleDate - format() : \n" + ex.message );
			}
			**/
			return sFormatedDate ;
		}
	}
	//------------------------------------------------------------------------------
	this.isNull = function () 
	{
		return ( _iDay == 0 ? true : false ) ;
	}
	//------------------------------------------------------------------------------
	this.getDay = function () 
	{
		return _iDay ;
	}
	//------------------------------------------------------------------------------
	this.getMonth = function () 
	{
		return _iMonth ;
	}
	//------------------------------------------------------------------------------
	this.getYear = function () 
	{
		return _iYear ;
	}
	//------------------------------------------------------------------------------
	this.getFormat = function () 
	{
		return _sFormat ;
	}
	//------------------------------------------------------------------------------
	this.setFormat = function ( sFormat ) // throws Error
	{
		// try {
			_parsedFormat = _parseFormat( sFormat ); // throws Error
			_sFormat      = sFormat ;
		/**
		}
		catch (ex) {
			alert ( "ERROR : \nSimpleDate - setFormat() : \n" + ex.message );
		}
		**/
	}
	//------------------------------------------------------------------------------
	this.setDate = function ( sDate ) // throws Error
	{
		// try {
			if ( sDate == null )
			{	
				_setNull();
			}
			else
			{
				var sSeparator  = null ;
				var sYearFormat = null ;
				if ( sDate.length == 6 ) // Only digits "DD", "MM", "YY"
				{
					sSeparator  = null ; // no separator
					sYearFormat = "YY" ; // Year on 2 digits
				}
				else if ( sDate.length == 8 ) // 6 digits + 2 separators OR 8 digits 
				{
					if ( sDate.indexOf("/") >= 0 ) // At least a "/"
					{
						sSeparator  = "/" ;  // separator
						sYearFormat = "YY" ; // Year on 2 digits
					}
					else if ( sDate.indexOf("-") >= 0 ) // At least a "-"
					{
						sSeparator  = "-" ;  // separator
						sYearFormat = "YY" ; // Year on 2 digits
					}
					else
					{
						sSeparator  = null ;   // no separator 
						sYearFormat = "YYYY" ; // Year on 4 digits
					}
				}
				else if ( sDate.length == 10 ) // 8 digits + 2 separators 
				{
					     if ( sDate.indexOf("/") >= 0 ) sSeparator  = "/" ;
					else if ( sDate.indexOf("-") >= 0 ) sSeparator  = "-" ;
					else throw new Error("Invalid date : " + sDate );
					sYearFormat = "YYYY" ;
				}
				else
				{
					throw new Error( "Invalid date : " + sDate );
				}
				
				//--- Copy the current parsed format (other instance)
				var parsedFormat = _parsedFormat.concat() ; // no "copy" method => use "concat()"
				//--- Set the new "INPUT FORMAT" for date parsing : can change 'YEAR format' (but keep order)
				for ( var i=0 ; i < 3 ; i++ )
				{
					if ( parsedFormat[i].charAt(0) == 'Y' )
					{
						parsedFormat[i] = sYearFormat ;
					}
				}
				//--- Set the separator detected in the date
				parsedFormat[3] = sSeparator ;
	
				//--- Build the Date Value 	
				_buildDateWithParsedFormat( sDate, parsedFormat ) ;
				
			}
		/**
		}
		catch (ex) {
			alert ( "ERROR : \nSimpleDate - setDate() : \n" + ex.message );
		}
		**/
	}
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// fwkScreenMessage.js
//------------------------------------------------------------------------------
// Version : 1.0  ( 12/12/2005 )
// Author  : Laurent Gurin 
// Changes : none (creation)
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenMessage( code, text, type )
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _iCode = code ;
	var _sText = text ;
	var _iType = type ;

	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.getCode = function () 
	{
		return _iCode ;
	}
	//------------------------------------------------------------------------------
	this.getText = function () 
	{
		return _sText ;
	}
	//------------------------------------------------------------------------------
	this.getType = function () 
	{
		return _iType ;
	}
	//------------------------------------------------------------------------------	
	this.toString = function () 
	{
		return "code=" + _iCode + " text='" + _sText + "' type=" + _iType ;
	}
}
//------------------------------------------------------------------------------
//                                THE  END
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// fwkFields.js : Gestion des champs de saisie (filtrage, validit & formatage)
//------------------------------------------------------------------------------
// Version : 2.0  ( 07/06/2005 )
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//==============================================================================
//          G E S T I O N   D E   L ' E T A T   D E S   C H A M P S  
//==============================================================================
//------------------------------------------------------------------------
var VG_fwkShallowCheckingErrorColor   = "white"  ; // Default error color
var VG_fwkShallowCheckingErrorBgColor = "#cc0000"; // Default error background color
var VG_fwkInvalidCharErrorColor       = "red"; 
//var VG_fwkDefaultStandardColor   = "blue";
//var VG_fwkDefaultStandardBgColor = "orange";
var VG_fwkFieldOnError = null ; // Variable Globale pour le timer
function fwkInvalidChar(oField)  
{
    VG_fwkFieldOnError = oField ;
    if ( oField.style.backgroundColor != VG_fwkInvalidCharErrorColor ) // Pour viter les pb de frappe clavier trs rapide
    {
	    var sInitialBgColor = oField.style.backgroundColor ;
	    //alert("initial BG-Color =" + sInitialBgColor );
		//VG_fwkFieldOnError.style.backgroundColor='red' ;	
		VG_fwkFieldOnError.style.backgroundColor=VG_fwkInvalidCharErrorColor ;
	    //window.setTimeout("VG_fwkFieldOnError.style.backgroundColor='white';", 50);
	    window.setTimeout("VG_fwkFieldOnError.style.backgroundColor='" + sInitialBgColor + "';", 50);
    }
}
/***
//------------------------------------------------------------------------
// Neutralisation de la couleur et des tats "erreur" d'un champ ( Reset )
//------------------------------------------------------------------------
function fwkResetFieldErrorStatus(oField)  //--- (Ver 1.2)
{
	oField.style.backgroundColor='white' ;
	oField.style.color= "#000066";
	oField.fwkErrorFlag = false ;
	oField.fwkShallowCheckingErrorFlag = false ;
}
***/
/***
//------------------------------------------------------------------------
// Marquage du champ pour une erreur fonctionnelle ( Foreign Key, etc... )
//------------------------------------------------------------------------
function fwkSetFieldErrorColor(oField)  //--- Champ en erreur
{
	oField.style.backgroundColor='red' ;
	oField.style.color='white';	
	oField.fwkErrorFlag = true ; // (Ver 1.2)
}
function fwkSetFieldStandardColor(oField)  //--- Champ OK ( couleur normale )
{
	//alert(oField.id + "fwkErrorFlag = "+ oField.fwkErrorFlag);
	oField.style.backgroundColor='white' ;
	oField.style.color= "#000066";
	oField.fwkErrorFlag = false ; // (Ver 1.2)
}
function fwkIsFieldOnError(oField)  //--- Le champ est-il en erreur (ETAT) (Ver 1.2)
{
	if ( oField == null ) return false ;
	if ( oField.fwkErrorFlag == null ) return false ;
	return oField.fwkErrorFlag ; 
}
***/
//------------------------------------------------------------------------
// Marquage du champ pour une erreur "superficielle" : controle de surface (format, .. )
//------------------------------------------------------------------------
//------------------------------------------------------------------------
function fwkDefineShallowCheckingErrorColors(sColor,sBgColor)
{
	VG_fwkShallowCheckingErrorColor   = sColor
	VG_fwkShallowCheckingErrorBgColor = sBgColor
}
//------------------------------------------------------------------------
function fwkSetFieldShallowCheckingErrorColor(oField) 
{
	oField.fwkShallowCheckingErrorFlag = true ;
	if ( ! oField.fwkInitialColor )
	{
		if ( oField.style.color )
		{
			//alert(  "fwkInitialColor NOT SET : storing style.color " + oField.style.color  );
			oField.fwkInitialColor = oField.style.color ;
		}
		else
		{
			//alert(  "fwkInitialColor NOT SET : no style.color => storing '?' "  );
			oField.fwkInitialColor = "?" ;
		}
	}
	if ( ! oField.fwkInitialBgColor )
	{
		if ( oField.style.backgroundColor )
		{
			oField.fwkInitialBgColor = oField.style.backgroundColor ;
		}
		else
		{
			oField.fwkInitialBgColor = "?" ;
		}
	}
	//--- Set the error colors 
	oField.style.color           = VG_fwkShallowCheckingErrorColor;	
	oField.style.backgroundColor = VG_fwkShallowCheckingErrorBgColor ;
}
//------------------------------------------------------------------------
//function fwkSetFieldShallowCheckingStandardColor(oField)
function fwkRestoreInitialColors(oField)
{
	if ( oField == null ) return ;
	if ( oField.fwkShallowCheckingErrorFlag == null ) return ;
	if ( oField.fwkShallowCheckingErrorFlag == false ) return ;
	
	oField.fwkShallowCheckingErrorFlag = false ;	
	if ( ! oField.fwkInitialColor )
	{
		oField.style.color = "" ;
	}
	else
	{
		if ( oField.fwkInitialColor == "?" )
		{
			//oField.style.color = null ; // OK on FireFox ( not OK on IE )
			oField.style.color = "" ; // OK on FireFox and IE
		}
		else
		{
			oField.style.color = oField.fwkInitialColor ;
		}
	}
	if ( ! oField.fwkInitialBgColor )
	{
		oField.style.backgroundColor = "" ;
	}
	else
	{
		if ( oField.fwkInitialBgColor == "?" )
		{
			//oField.style.backgroundColor = null ; // OK on FireFox ( not OK on IE )
			oField.style.backgroundColor = "" ; // OK on FireFox and IE
		}
		else
		{
			oField.style.backgroundColor = oField.fwkInitialBgColor ;
		}
	}
}
//------------------------------------------------------------------------
/***
function fwkIsFieldOnShallowCheckingError(oField) 
{
	if ( oField == null ) return false ;
	if ( oField.fwkShallowCheckingErrorFlag == null ) return false ;
	return oField.fwkShallowCheckingErrorFlag ; 
}
***/
//------------------------------------------------------------------------
function fwkGetOptionalChars(sType)  
{
	if ( sType == null ) return "" ;
	var i = sType.indexOf(":") ;
	if ( i >= 0 ) 
	{
		return sType.substr(i+1) ;
	}
	return "";
}
//------------------------------------------------------------------------
function fwkGetPureType(sType)
{
	if ( sType == null ) return "" ;
	var i = sType.indexOf(":") ;
	if ( i >= 0 ) 
	{
		return sType.substr(0, i) ;
	}
	return sType;	
}
//==============================================================================
//                     KEY CODE (CHARACTER) INPUT FILTER 
//------------------------------------------------------------------------------
// Use this function in the "onKeyPress" event to call this function for 
// each key press by the user
//==============================================================================
function fwkFilter(oEvent, oField, sType)  
{
	if ( oEvent == null )
	{
		alert ( "ERROR on fwkFilter() : No event parameter !" );
		return ;
	}
	if ( oField == null )
	{
		alert ( "ERROR on fwkFilter() : No field parameter !" );
		return ;
	}
	
	if ( sType == null ) return ;
	//fwkSetFieldShallowCheckingStandardColor(oField);

	var sOptionalChars = fwkGetOptionalChars(sType);
	var sPureType      = fwkGetPureType(sType);
	var sPureTypeUC    = sPureType.toUpperCase() ;
	
	if      ( sPureTypeUC == "INT"        ) return fwkIntFilter     (oEvent, oField, sOptionalChars) ;
	else if ( sPureTypeUC == "NUM"        ) return fwkNumFilter     (oEvent, oField, sOptionalChars) ;
	else if ( sPureTypeUC == "ALPHANUMUC" ) return fwkAlphaNumFilter(oEvent, oField, sOptionalChars, "U" ) ;
	else if ( sPureTypeUC == "ALPHANUMLC" ) return fwkAlphaNumFilter(oEvent, oField, sOptionalChars, "L" ) ;
	else if ( sPureTypeUC == "ALPHANUM"   ) return fwkAlphaNumFilter(oEvent, oField, sOptionalChars, ""  ) ;
	else if ( sPureTypeUC == "ALPHAUC"    ) return fwkAlphaFilter   (oEvent, oField, sOptionalChars, "U" ) ;
	else if ( sPureTypeUC == "ALPHALC"    ) return fwkAlphaFilter   (oEvent, oField, sOptionalChars, "L" ) ;
	else if ( sPureTypeUC == "ALPHA"      ) return fwkAlphaFilter   (oEvent, oField, sOptionalChars, ""  ) ;
	else if ( sPureTypeUC == "DATE"       ) return fwkDateFilter    (oEvent, oField) ;
	else if ( sPureTypeUC == "SELECTUC"   ) return fwkSelectFilter  (oEvent, oField, sOptionalChars, "U" ) ;
	else if ( sPureTypeUC == "SELECTLC"   ) return fwkSelectFilter  (oEvent, oField, sOptionalChars, "L" ) ;
	else if ( sPureTypeUC == "SELECT"     ) return fwkSelectFilter  (oEvent, oField, sOptionalChars, ""  ) ;
}
//------------------------------------------------------------------------
function fwkGetKeyCode(oEvent)  
{
	if ( window.event )
	{
		//--- Internet Explorer
		window.status = "I.E. : event.keyCode = " + oEvent.keyCode + " / window.event.keyCode = " + window.event.keyCode  ;
		return window.event.keyCode ;
	}
	else
	{
		//--- Mozilla / Firefox
		if ( oEvent.keyCode ) // Ctrl Key ( Backspace, Home, Arrows, ... ) 
		{
			//window.status = "Mozilla/Firefox : keyCode = " + oEvent.keyCode ;
			return 0 ;
		}
		else if ( oEvent.which ) // Character 
		{
			//window.status = "Mozilla/Firefox : which = " + oEvent.which + " / charCode = " + oEvent.charCode ;
			return oEvent.which ;
		}
		return 0;
	}
}
//------------------------------------------------------------------------
function fwkSetKeyCode(oEvent, iNewKeyCode )  
{
	if ( window.event ) //--- Internet Explorer
	{
		window.status = "I.E. : initial keyCode = " + window.event.keyCode  + " / new keyCode = " + iNewKeyCode  ;
		window.event.keyCode = iNewKeyCode ;
	}
	else if ( oEvent.initKeyEvent ) //--- Mozilla / Firefox
	{
		oEvent.initKeyEvent('keypress', true, true, window, false, false, false, false, 0, iNewKeyCode );
	}
}
//------------------------------------------------------------------------
// Fonction de filtrage des caractres saisis pour un champ ENTIER
//------------------------------------------------------------------------
function fwkIntFilter(oEvent, oField, sOpt) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 
	if ( iCar >= 48 && iCar <= 57 ) // Chiffres ( 0  9 )
	{
		return true ; // OK
	}
	else 
	{
		if ( sOpt != null )
		{
			// S'agit-il d'un caractre optionnel ?
			var sAuthorized = "+-" ; // Les seuls caractres optionnels autoriss 
			var sCar = String.fromCharCode(iCar) ;
			if ( ( sAuthorized.indexOf(sCar) >= 0 ) && ( sOpt.indexOf(sCar) >= 0 ) )
			{
				return true ;
				// Vrification qu'un de ces caractres n'a pas dj t saisi 
				/*  Problmatique si le champ est "selected" et que le car  dj t saisi
				if (  ( window.event.srcElement.value.indexOf("-") < 0 )
				   && ( window.event.srcElement.value.indexOf("+") < 0 ) )
				{
					return true ;
				}
				*/
			}
		}
	}
	//--- Dans tous les autres cas : Caractre refus 	
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ NUMERIQUE
//------------------------------------------------------------------------
function fwkNumFilter(oEvent, oField, sOpt) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 
	if ( ( iCar >= 48 && iCar <= 57 ) || ( iCar == 46 ) ) // Chiffres ( 0  9 ) plus le POINT 
	{
		return true ;
	}
	else 
	{
		// S'agit-il d'un caractre optionnel ?
		var sAuthorized = "+-" ; // Les seuls caractres optionnels autoriss 
		var sCar = String.fromCharCode(iCar) ;
		if ( ( sAuthorized.indexOf(sCar) >= 0 ) && ( sOpt.indexOf(sCar) >= 0 ) )
		{
			return true ;
		}
	}
	//--- Dans tous les autres cas : Caractre refus 	
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// 
//------------------------------------------------------------------------
function privateAlphaFilter(iCar, sOpt, sUpperLower ) 
{
	//--- Lettres majuscules ( A-Z )
	if ( iCar >=  65 && iCar <=  90 ) 
	{
		if ( sUpperLower == "L" ) // Lower Case  
		{
			return iCar + 32;  // Convert
		}
		return iCar ;
	}
	//--- Lettres minuscules ( a-z )
	if ( iCar >=  97 && iCar <= 122 ) 
	{
		if ( sUpperLower == "U" ) // Upper Case 
		{
			return iCar - 32;  // Convert
		}
		return iCar ;
	}
	//--- Lettres accentues (          etc... )
	if ( iCar >= 194 )
	{
		return iCar ;
	}
	//--- Caractre optionnel ?
	var sCar = String.fromCharCode(iCar) ;
	if ( sOpt.indexOf(sCar) >= 0 )
	{
		return iCar ;
	}
	//--- Dans tous les autres cas : Caractre refus 	
	return 0 ;
}

//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ ALPHABETIQUE PUR
//------------------------------------------------------------------------
function fwkAlphaFilter(oEvent, oField, sOpt, sUpperLower ) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 
	
	var iFilteredChar = privateAlphaFilter(iCar, sOpt, sUpperLower ) ;
	if ( iFilteredChar != 0 ) // Char OK
	{
		if ( iFilteredChar != iCar ) 
		{
			//--- Re-Set the Character (can be converted)
			fwkSetKeyCode(oEvent, iFilteredChar )  
		} 
		return true ;
	}
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ ALPHANUMERIQUE
//------------------------------------------------------------------------
function fwkAlphaNumFilter(oEvent, oField, sOpt, sUpperLower ) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 
	
	//--- Chiffres ( 0  9 )
	if ( iCar >= 48 && iCar <= 57 ) // Chiffres ( 0  9 )
	{
		return true ;
	}

	var iFilteredChar = privateAlphaFilter(iCar, sOpt, sUpperLower ) ;
	if ( iFilteredChar != 0 ) // Char OK
	{
		if ( iFilteredChar != iCar ) 
		{
			//--- Re-Set the Character (can be converted)
			fwkSetKeyCode(oEvent, iFilteredChar )  
		}
		return true ;
	}
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ DATE
//------------------------------------------------------------------------
function fwkDateFilter(oEvent, oField) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 

	if ( iCar >= 47 && iCar <= 57 ) // "/" ou chiffre ( 0  9 ) 
	{
		return true ;
	}
	//--- Dans tous les autres cas : Caractre refus 	
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ SELECT
//------------------------------------------------------------------------
function fwkSelectFilter(oEvent, oField, sSelectedChars, sUpperLower ) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	var iNewChar = iCar ;
	if ( iCar < 31 ) return true ; 

	//--- Conversion ventuelle en majuscules ou minuscules
	if ( ( iCar >=  65 && iCar <=  90 ) && ( sUpperLower == "L" ) ) 
	{
		iNewChar = iCar + 32;  // Convert to Lower Case 
	}
	else if ( ( iCar >=  97 && iCar <= 122 ) && ( sUpperLower == "U" ) )
	{
		iNewChar = iCar - 32;  // Convert to Upper Case
	}
	//--- Le caractre fait-il partie de la liste des caractres acceptables ?
	var sNewChar = String.fromCharCode(iNewChar) ;
	if ( sSelectedChars.indexOf(sNewChar) >= 0 )
	{
		if ( iNewChar != iCar ) 
		{
			//--- Re-Set the Character (can be converted)
			fwkSetKeyCode(oEvent, iNewChar )  
		}	
		return true ;
	}
	//--- Dans tous les autres cas : Caractre refus
	fwkInvalidChar(oField);
	return false ;
}

//==============================================================================
//    C O N T R O L E    D E    V A L I D I T E    E T    F O R M A T A G E
//==============================================================================
//------------------------------------------------------------------------
// Check the field is not null
// ( associe  l'vnement "onBlur" )
//------------------------------------------------------------------------
function fwkCheckNotNull(oField )  
{
	if ( oField == null )
	{
		alert ( "ERROR on fwkCheckNotNull() : No field parameter !" );
		return ;
	}
	if ( oField.value == null || oField.value == "" )
	{
		//--- This field is null => error
		fwkSetFieldShallowCheckingErrorColor(oField); 
	}
	else
	{
		//--- This field is not null => OK
		//if ( fwkIsFieldOnShallowCheckingError(oField) )
		//{
		//	fwkSetFieldShallowCheckingStandardColor(oField); 
		//}
		fwkRestoreInitialColors(oField);
	}
}
//------------------------------------------------------------------------
// Check the field match the regular expression
// ( associe  l'vnement "onBlur" )
//------------------------------------------------------------------------
function fwkCheckRegExp(oField, bCanBeNull, sRegExp )  
{
	if ( oField == null )
	{
		alert ( "ERROR on fwkCheckRegExp() : No field parameter !" );
		return ;
	}
	var sFieldValue = oField.value ;
	if ( sFieldValue == null || sFieldValue == "" )
	{
		if ( bCanBeNull == false ) // NOT NULL
		{
			//--- The field is null and it's not authorized => ERROR
			fwkSetFieldShallowCheckingErrorColor(oField); 
		}
		else
		{
			//--- The field is null, but it's authorized => OK
			//if ( fwkIsFieldOnShallowCheckingError(oField) )
			//{
			//	fwkSetFieldShallowCheckingStandardColor(oField);
			//}
			fwkRestoreInitialColors(oField);
		}
		return ;
	}
	else
	{
		var re = new RegExp( sRegExp );
		if ( ! sFieldValue.match(re) )
		{
			//--- The field doesn't match the Reg Exp => ERROR
			fwkSetFieldShallowCheckingErrorColor(oField); 
		}
		else
		{
			//--- The field match the Reg Exp  => OK
			//if ( fwkIsFieldOnShallowCheckingError(oField) )
			//{
			//	fwkSetFieldShallowCheckingStandardColor(oField);
			//}
			fwkRestoreInitialColors(oField);
		}	
	}
}
//------------------------------------------------------------------------
// Fonction de controle de validit et de formatage du champ selon son type
// ( associe  l'vnement "onBlur" )
//------------------------------------------------------------------------
function fwkCheckField(oField, bCanBeNull, sType, MinValue, MaxValue, sFormat )  
{
	if ( oField == null )
	{
		alert ( "ERROR on fwkCheckField() : No field parameter !" );
		return ;
	}
	if ( sType == null )
	{
		alert ( "ERROR on fwkCheckField() : No type parameter !" );
		return ;
	}

	var sPureType = fwkGetPureType(sType);
	var sPureTypeUC = sPureType.toUpperCase() ;
	//alert( "fwkCheckField() : Type = "+ sType + " => Pure Type = " + sPureType + " => Pure Type UC = " + sPureTypeUC) ;

/***
	//--- Si le champs est dans un tat "erreur fonctionnelle" ( ForeignKey, etc ... )
	if ( fwkIsFieldOnError(oField) )
	{
		// pour traiter le cas d'une re-saisie  l'identique qui ne provoque pas de "OnChange" 
		fwkSetFieldErrorColor(oField); //--- R-affectation de la couleur correspondant  son tat
		
		// Mise en commentaire YMO: Ne prends pas encompte le reformatage de la nouvelle valeur
		// si celle ci est correcte
		//return ; // Inutile d'aller plus loin
	}
***/
	var bRet = true ;
	var sFieldValue = oField.value ;
	//--- Controle de champ null 
	if ( sFieldValue == null || sFieldValue == "" )
	{
		if ( bCanBeNull == false ) // NOT NULL
		{
			bRet = false ;
		}
	}
	else // Champ pas null
	{
		var sOptionalChars = fwkGetOptionalChars(sType);
		//--- Controles de validit du champ  
		if      ( sPureTypeUC == "INT"        ) bRet = fwkCheckInt      (sFieldValue, MinValue, MaxValue) ;
		else if ( sPureTypeUC == "NUM"        ) bRet = fwkCheckNum      (sFieldValue, MinValue, MaxValue) ;
		else if ( sPureTypeUC == "DATE"       ) bRet = fwkCheckDate     (sFieldValue) ;
		else if ( sPureTypeUC == "ALPHA"      ) bRet = fwkCheckAlpha    (sFieldValue, sOptionalChars, ""  ) ;
		else if ( sPureTypeUC == "ALPHAUC"    ) bRet = fwkCheckAlpha    (sFieldValue, sOptionalChars, "U" ) ;
		else if ( sPureTypeUC == "ALPHALC"    ) bRet = fwkCheckAlpha    (sFieldValue, sOptionalChars, "L" ) ;
		else if ( sPureTypeUC == "ALPHANUM"   ) bRet = fwkCheckAlphaNum (sFieldValue, sOptionalChars, ""  ) ;
		else if ( sPureTypeUC == "ALPHANUMUC" ) bRet = fwkCheckAlphaNum (sFieldValue, sOptionalChars, "U" ) ;
		else if ( sPureTypeUC == "ALPHANUMLC" ) bRet = fwkCheckAlphaNum (sFieldValue, sOptionalChars, "L" ) ;
		else if ( sPureTypeUC == "SELECT"     ) bRet = fwkCheckSelect   (sFieldValue, sOptionalChars ) ;
		else if ( sPureTypeUC == "SELECTUC"   ) bRet = fwkCheckSelect   (sFieldValue, sOptionalChars ) ;
		else if ( sPureTypeUC == "SELECTLC"   ) bRet = fwkCheckSelect   (sFieldValue, sOptionalChars ) ;
	}
	if ( bRet == false ) //--- Valeur incorrecte  	
	{
		fwkSetFieldShallowCheckingErrorColor(oField); 
	}
	else //--- Valeur correcte  
	{
		//--- Champ de couleur normale 
		//if ( fwkIsFieldOnShallowCheckingError(oField) )
		//{
		//	fwkSetFieldShallowCheckingStandardColor(oField);
		//}
		fwkRestoreInitialColors(oField);

		//--- Formatage 
		if ( sFieldValue != null && sFieldValue != "" )
		{
			if      ( sPureTypeUC == "INT"      ) oField.value = fwkFormatInt (sFieldValue, sFormat) ;
			else if ( sPureTypeUC == "NUM"      ) oField.value = fwkFormatNum (sFieldValue, sFormat) ;
			else if ( sPureTypeUC == "DATE"     ) oField.value = fwkFormatDate(sFieldValue, sFormat) ;
		}
	}
}

//------------------------------------------------------------------------
// Controle de cohrence des lments Jour, Mois et Anne d'une date 
//------------------------------------------------------------------------
function fwkValidDate(sJour, sMois, sAnnee) // return type : Boolean
{
	// alert("fwkValidDate('"+sJour+"', '"+sMois+"', '"+sAnnee+"') " ) ;
	try 
	{
		var nbJours = new Array(0,31,28,31,30,31,30,31,31,30,31,30,31);
		var j = parseInt(sJour,10) ;
		var m = parseInt(sMois,10) ;
		var a = parseInt(sAnnee,10) ;
		//--- Si Anne bissextile
		if ( ( a%4 == 0 && a%100 != 0 ) || a%400 == 0 )  nbJours[2] = 29  ; // 29 jours en Fvrier
		
		//alert("fwkValidDate("+j+","+m+","+a+") nbJours[2] = " + nbJours[2] + "  nbJours[m] = " + nbJours[m] ) ;
		//window.status = "fwkValidDate("+j+","+m+","+a+") nbJours[2] = " + nbJours[2] + "  nbJours[m] = " + nbJours[m] ;
	
		//--- Validite de l'Annee
		if ( ( a < 0 ) || ( a > 9999 ) )  return false ;
		//--- Validite du Mois
		if ( ( m < 1 ) || ( m > 12 ) )  return false ;
		//--- Validite du Jour 
		if ( ( j < 1 ) || ( j > nbJours[m] ) )  return false ;
		//--- OK : Date valide  
		return true ;
	}
	catch (e) 
	{
		window.status = "fwkValidDate : Exception"  ;
		return false ;
	}
}
//------------------------------------------------------------------------
// Controle de validit d'un champ de type DATE 
//------------------------------------------------------------------------
//function fwkCheckDate(oField) // return type : Boolean
function fwkCheckDate(sFieldValue) // return type : Boolean
{
var i, c ;
var JJ, MM, AA ;

	if ( sFieldValue.length == 6 ) // "JJMMAA" (ne doit contenir que des chiffres)
	{
		//------------------------------------------------------
		// 6 caractres => format attendu : "JJMMAA"
		//------------------------------------------------------
		for ( i = 0 ; i < 6 ; i++ ) //--- Chiffre uniquement ( pas de  "/" )
		{
			c = sFieldValue.charCodeAt(i) ;
			if ( c < 48 || c > 57 ) return false ;
		}
        JJ   = sFieldValue.substr(0,2);
        MM   = sFieldValue.substr(2,2);
        AA   = sFieldValue.substr(4,2);
		return fwkValidDate(JJ, MM, AA) ;
	}
	else if ( sFieldValue.length == 8 ) // "JJ/MM/AA" ou "JJMMAAAA" 
	{
		if ( sFieldValue.indexOf("/") >= 0 ) // Si il y a au moins un "/"
		{
			//------------------------------------------------------
			// 8 caractres avec "/" => format attendu : "JJ/MM/AA"
			//------------------------------------------------------
			for ( i = 0 ; i < 8 ; i++ ) //--- Chiffre + "/" (code 47) en position 2 et 5
			{
				c = sFieldValue.charCodeAt(i) ;
				if (      ( c < 47 || c > 57 )  
				      ||  ( ( c == 47 ) && ( ( i != 2 ) && ( i != 5 ) )  )    
				      ||  ( ( c != 47 ) && ( ( i == 2 ) || ( i == 5 ) )  )
				   )
				{
					return false ;
				}
			}
			JJ   = sFieldValue.substr(0,2);
	        MM   = sFieldValue.substr(3,2);
	        AA   = sFieldValue.substr(6,2);
			return fwkValidDate(JJ, MM, AA) ;
		}
		else
		{
			//------------------------------------------------------
			// 8 caractres sans "/" => format attendu : "JJMMAAAA"
			//------------------------------------------------------
			for ( i = 0 ; i < 8 ; i++ ) //--- Chiffre uniquement ( pas de  "/" )
			{
				c = sFieldValue.charCodeAt(i) ;
				if ( c < 48 || c > 57 ) return false ;
			}
	        JJ   = sFieldValue.substr(0,2);
	        MM   = sFieldValue.substr(2,2);
	        AA   = sFieldValue.substr(4,4);
			return fwkValidDate(JJ, MM, AA) ;
		}
	}
	else if ( sFieldValue.length == 10 ) // "JJ/MM/AAAA"
	{
		//------------------------------------------------------
		// 10 caractres => format attendu : "JJ/MM/AAAA"
		//------------------------------------------------------
		for ( i = 0 ; i < 10 ; i++ )//--- Chiffre + "/" (code 47) en position 2 et 5
		{
			c = sFieldValue.charCodeAt(i) ;
			if (      ( c < 47 || c > 57 )  
			      ||  ( ( c == 47 ) && ( ( i != 2 ) && ( i != 5 ) )  )    
			      ||  ( ( c != 47 ) && ( ( i == 2 ) || ( i == 5 ) )  )
			   )
			{
				return false ;
			}
		}
        JJ   = sFieldValue.substr(0,2);
        MM   = sFieldValue.substr(3,2);
        AA   = sFieldValue.substr(6,4);
		return fwkValidDate(JJ, MM, AA) ;
	}
	else if ( sFieldValue.length != 0 )
	{
		return false ;
	}
	return true ; // Date OK
}

//------------------------------------------------------------------------
// Controle de validit d'un champ de type ENTIER 
//------------------------------------------------------------------------
//function fwkCheckInt(oField) // return type : Boolean
function fwkCheckInt(sFieldValue, iMinValue, iMaxValue) // return type : Boolean
{      
	var re = new RegExp("^[-+]?[0-9]*$");
	if ( ! sFieldValue.match(re) )
	{
		return false ;
	}
/*
	//--- Si le signe n'est pas au dbut ( position ZERO ) => erreur
	if ( sFieldValue.lastIndexOf("-") > 0 ) return false ;
	if ( sFieldValue.lastIndexOf("+") > 0 ) return false ;
*/
	
	var iFieldValue = parseInt(sFieldValue,10) ;
	// NB: parseInt ne controle pas la validit ( "2 2" -> 2, "2a" -> 2, etc...)
	// et ne lve pas d'exception (renvoie NaN si aucun parsing possible)

	//--- Si le nombre n'est pas dans la fourchette autorise
	if ( iMinValue != null && iFieldValue < iMinValue ) return false;
	if ( iMaxValue != null && iFieldValue > iMaxValue ) return false;

	//--- Dans tous les autres cas, Champ OK
	return true ;
}


//------------------------------------------------------------------------
// Controle de validit d'un champ de type NUMERIQUE 
//------------------------------------------------------------------------
//function fwkCheckNum(oField) // return Boolean
function fwkCheckNum(sFieldValue, fMinValue, fMaxValue) // return Boolean
{      
	var re = new RegExp("^[-+]?[0-9\.]*$");
	if ( ! sFieldValue.match(re) )
	{
		return false ;
	}
/**
	//--- Si le signe n'est pas au dbut ( position ZERO ) 
	// ( et s'il y en a plusieurs, ils ne peuvent pas tre tous  la position 0 )
	if ( sFieldValue.lastIndexOf("-") > 0 ) return false ;
	if ( sFieldValue.lastIndexOf("+") > 0 ) return false ;
**/

	//--- Si il y a plus d'une marque dcimale ( . )
	var i  = 0;
	var nb = 0;
	for ( i = 0 ; i < sFieldValue.length ; i++ )
	{
		if ( sFieldValue.charAt(i) == '.' ) nb ++;
	}
	if ( nb > 1 ) return false ;

	//--- Si le nombre n'est pas dans la fourchette autorise
	if ( fMinValue != null && parseFloat(sFieldValue) < fMinValue ) return false;
	if ( fMaxValue != null && parseFloat(sFieldValue) > fMaxValue ) return false;

	//--- Dans tous les autres cas, Champ OK
	return true ;
}

//------------------------------------------------------------------------
function fwkCheckCharAlpha (c, sOpt, sUpperLower ) // return Boolean
{
	if ( c >=  65 && c <=  90 ) //--- Lettres majuscules ( A-Z )
	{
		if ( sUpperLower == "L" ) // Lower Case  
		{
			return false ; 
		}
		return true ; // OK
	}
	else if ( c >=  97 && c <= 122 ) //--- Lettres minuscules ( a-z )
	{
		if ( sUpperLower == "U" ) // Upper Case 
		{
			return false;
		}
		return true ; // OK
	}
	else if ( c >= 194 ) //--- Lettres accentues (          etc... )
	{
		return true ; // OK
	}
	else //--- Caractre optionnel ?
	{
		if ( sOpt.indexOf(String.fromCharCode(c)) < 0 )
		{
			return false ;
		}
	}
	//--- OK le caractre est acceptable
	return true ;
}
//------------------------------------------------------------------------
//------------------------------------------------------------------------
function fwkCheckAlpha (sFieldValue, sOpt, sUpperLower ) // return Boolean
{
	//window.status = "fwkCheckAlpha("+sFieldValue+","+sOpt+","+sUpperLower+")" ;
	var c = 0 ;
	for ( var i = 0 ; i < sFieldValue.length ; i++ )
	{
		c = sFieldValue.charCodeAt(i) ;
		if ( fwkCheckCharAlpha (c, sOpt, sUpperLower ) == false ) 
		{
			return false ;
		}
	}
	//--- OK (tous les caractres sont acceptables)
	return true ;
}
//------------------------------------------------------------------------
//------------------------------------------------------------------------
function fwkCheckAlphaNum (sFieldValue, sOpt, sUpperLower ) // return Boolean
{
	//window.status = "fwkCheckAlphaNum("+sFieldValue+","+sOpt+","+sUpperLower+")" ;
	var c = 0 ;
	for ( var i = 0 ; i < sFieldValue.length ; i++ )
	{
		c = sFieldValue.charCodeAt(i) ;
		//--- Chiffres ( 0  9 )
		if ( c >= 48 && c <= 57 ) // Chiffres ( 0  9 )
		{
			continue; // OK
		}
		else
		{
			if ( fwkCheckCharAlpha (c, sOpt, sUpperLower ) == false ) 
			{
				return false ;
			}
		}
	}
	//--- OK (tous les caractres sont acceptables)
	return true ;
}
//------------------------------------------------------------------------
function fwkCheckSelect (sFieldValue, sOpt ) // return Boolean
{
	window.status = "fwkCheckSelect"+sFieldValue+","+sOpt+")" ;
//	var c = 0 ;
	for ( var i = 0 ; i < sFieldValue.length ; i++ )
	{
//		c = sFieldValue.charCodeAt(i) ;		
//		if ( sOpt.indexOf(String.fromCharCode(c)) < 0 )
		if ( sOpt.indexOf(sFieldValue.charAt(i)) < 0 )
		{
			return false ;
		}
	}
	//--- OK (tous les caractres sont acceptables)
	return true ;
}

//==============================================================================
//    FORMAT FUNCTIONS 
//==============================================================================
//------------------------------------------------------------------------
// Formatage d'un champ de type DATE
//------------------------------------------------------------------------
function fwkFormatDateYMD( sYear, sMonth, sDay, sFormat) // return type : String ( Formated Value )
{
	var sFormatUC = "DD/MM/YYYY" ; // Default Format = French format
	if ( sFormat != null )  sFormatUC = sFormat.toUpperCase();

	if ( sDay == null || sMonth == null || sYear == null )
	{
		alert("ERROR : fwkFormatDateDMY : Day or Month or Year is null ! " );
		return "";
	}
	/**
	if ( isNaN(sD) || isNaN(sM) || isNaN(sY) )
	{
		alert("ERROR : fwkFormatDateDMY : Day or Month or Year is not a number ! " );
		return "";
	}
	**/
	var sDD = null ;
	var sMM = null ;
	var sYY = null ;
	var sYYYY = null ;
	try {
		var iDay = parseInt(sDay,10) ;
		if ( iDay < 1 || iDay > 31 )
		{
			alert("ERROR : fwkFormatDateYMD : Invalid day " + iDay ) ;
			return "";
		}
		var iMonth = parseInt(sMonth,10) ;
		if ( iMonth < 1 || iMonth > 12 )
		{
			alert("ERROR : fwkFormatDateYMD : Invalid month " + iMonth ) ;
			return "";
		}
		var iYear = parseInt(sYear,10) ;
		if ( iYear < 0 || iYear > 9999 )
		{
			alert("ERROR : fwkFormatDateYMD : Invalid year " + iYear ) ;
			return "";
		}
	
		if ( iDay < 10 ) sDD = "0"+iDay; 
		else             sDD =  ""+iDay ;

		if ( iMonth < 10 ) sMM = "0"+iMonth;
		else               sMM =  ""+iMonth ;

		if ( iYear >= 1000 && iYear <= 9999 )
		{
			sYYYY = ""+iYear ;
		}
		else if ( iYear >= 100 && iYear <= 999 )
		{
			sYYYY = "2"+iYear ;
		}
		else if ( iYear >= 10 && iYear <= 99 )
		{
			sYYYY = "20"+iYear ;
		}
		else if ( iYear > 0 && iYear <= 9 )
		{
			sYYYY = "200"+iYear ;
		}
		sYY = sYYYY.substr(2,2);
		
		//TODO : Remplacer par substitution REGEXP
		if ( sFormatUC == "DD/MM/YYYY" ) return sDD+"/"+sMM+"/"+sYYYY ;
		if ( sFormatUC == "DD/MM/YY"   ) return sDD+"/"+sMM+"/"+sYY ;
		if ( sFormatUC == "MM/DD/YYYY" ) return sMM+"/"+sDD+"/"+sYYYY ;
		if ( sFormatUC == "MM/DD/YY"   ) return sMM+"/"+sDD+"/"+sYY ;
		if ( sFormatUC == "DD-MM-YYYY" ) return sDD+"-"+sMM+"-"+sYYYY ;
		if ( sFormatUC == "DD-MM-YY"   ) return sDD+"-"+sMM+"-"+sYY ;
		if ( sFormatUC == "MM-DD-YYYY" ) return sMM+"-"+sDD+"-"+sYYYY ;
		if ( sFormatUC == "MM-DD-YY"   ) return sMM+"-"+sDD+"-"+sYY ;
	} catch(ex) {
		alert("ERROR : fwkFormatDateYMD : Year = " + sYear + " Month = " + sMonth + " Day = " + sDay + " : Exception " + ex.message );		
	}
	
	
}
//------------------------------------------------------------------------
function fwkFormatDate(sVal, sFormat) // return type : String ( Formated Value )
{
var sDD, sMM, sYY, sYYYY ;

	//--- Si le champ est vide => pas de formatage
	if ( sVal == null ) return sVal ;
	if ( sVal.length == 0 ) return sVal ;
	
	var sFormatUC = "DD/MM/YYYY" ; // Default Format
	if ( sFormat != null )  sFormatUC = sFormat.toUpperCase();

	//--- Si il y a dj des sparateurs => pas de formatage
	if ( sVal.indexOf("/") >= 0 ) 
	{
		return sVal ;
	}
	else if ( sVal.length == 6 ) // "DDMMYY" 
	{
		sDD   = sVal.substr(0,2);
		sMM   = sVal.substr(2,2);
		sYY   = sVal.substr(4,2);
		sYYYY = "20"+sYY ;
	}  
	else if ( sVal.length == 8 ) // "DDMMYYYY"  
	{
		sDD   = sVal.substr(0,2);
		sMM   = sVal.substr(2,2);
		sYY   = sVal.substr(4,2);
		sYYYY = sVal.substr(4,4);
	}
	else
	{
		return sVal ;	
	}
	if ( sFormatUC == "DD/MM/YYYY" ) 
	{
		return sDD+"/"+sMM+"/"+sYYYY ;
	}
	else if ( sFormatUC == "DD/MM/YY" ) 
	{
		return sDD+"/"+sMM+"/"+sYY ;
	}
	/***
	else if ( sFormatUC == "DD-MM-YYYY" ) 
	{
		return sDD+"-"+sMM+"-"+sYYYY ;
	}
	else if ( sFormatUC == "DD-MM-YY" ) 
	{
		return sDD+"-"+sMM+"-"+sYY ;
	}
	else if ( sFormatUC == "MM-DD-YYYY" )  // American format
	{
		return sMM+"-"+sDD+"-"+sYYYY ;
	}
	else if ( sFormatUC == "MM-DD-YY" ) // American format
	{
		return sMM+"-"+sDD+"-"+sYY ;
	}
	else if ( sFormatUC == "YYYY-MM-DD" )  // ISO
	{
		return sYYYY+"-"+sMM+"-"+sDD ;
	}
	***/
	else // No Format
	{
		return sVal ;
	}
}

//------------------------------------------------------------------------
// Formatage d'un champ de type ENTIER
//------------------------------------------------------------------------
//function fwkFormatInt(oField, sFormat) // return type : Void
function fwkFormatInt(sVal, sFormat) // return type : String ( Formated Value )
{
	//--- Si le champ est vide => pas de formatage
	if ( sVal == null ) return sVal ;
	if ( sVal.length == 0 ) return sVal ;

	if ( sFormat == null )       return sVal ;
//	if ( oField.value.length == 0 ) return ; 	//--- Si le champ est vide => pas de formatage

//	var sVal         = oField.value ;   // Valeur originale du champ 
	var sSigne       = "" ;  // Signe de la valeur originale
	var sUnsignedVal = "" ;  // Valeur originale sans le signe
	var sNewVal      = "" ;  // Valeur formate 
	
	//--- Sparation du signe et de la valeur non signe  
	sSigne  = sVal.charAt(0) ; // Aprs controle de validit, le signe (s'il existe) est forcment au dbut
	if ( ( sSigne == "-" ) || ( sSigne == "+" ) )  
	{
		sUnsignedVal = sVal.substr(1) ;
	}
	else
	{
		sSigne = "+" ; // par dfaut 
		sUnsignedVal = sVal ;
	}
	//alert ( "sSigne = "+sSigne + " sUnsignedVal = "+sUnsignedVal ) ;	
	
	//--- Remplissage  gauche avec des ZEROS ?
	var sFiller   = null ;
	var iNbDigits = 0 ;
	if ( sFormat.indexOf("0") >= 0 ) sFiller = "0" ;
	if ( sFiller != null ) 
	{
		var i = 0
		//--- Nb de caractres attendus (dans le format)
		for ( i = 0 ; i < sFormat.length ; i++ )
		{
			if ( sFormat.charAt(i) == '0' ) iNbDigits++ ;
		}
		//--- Nb caractres de remplissage  ajouter
		var iDeltaSize = iNbDigits - sUnsignedVal.length ; 
		if ( iDeltaSize < 0 ) iDeltaSize = 0 ;
		//--- Composition de la chaine de caractres formate sans le signe
		sNewVal = "" ;
		for ( i = 0 ; i < iDeltaSize ; i++ )
		{
			sNewVal += sFiller;
		}
		sNewVal += sUnsignedVal ;
	}
	else
	{
		//--- Aucun formatage 
		sNewVal = sUnsignedVal ;
	}
	//alert ( "sNewVal avant mise en plce du signe = "+sNewVal ) ;	

	//--- Mise en place du signe (si ncessaire)
	if ( sFormat.indexOf("+") >= 0 ) // On veut toujours un signe ( + ou - )
	{
		sNewVal = sSigne + sNewVal ;
	}
	else if ( sFormat.indexOf("-") >= 0 ) // On veut un signe uniquement si ngatif ( - )
	{
		if  ( sSigne == "-" ) sNewVal = sSigne + sNewVal ; // On garde le "-" 
	}
	else  // Aucune exigence au niveau du format 
	{
		if  ( sSigne == "-" ) sNewVal = sSigne + sNewVal ; // On garde que le signe "-" 
	}

	//--- Affectation de la valeur formate dans le champ de saisie
	//oField.value = sNewVal ;      
	return sNewVal ;
}

//------------------------------------------------------------------------
// Formatage d'un champ de type NUMERIQUE
//------------------------------------------------------------------------
//function fwkFormatNum(oField, sFormat) // formatage 
function fwkFormatNum(sVal, sFormat) // // return type : String ( Formated Value ) 
{
	//--- Si le champ est vide => pas de formatage
	if ( sVal == null )     return sVal ;
	if ( sVal.length == 0 ) return sVal ;

	if ( sFormat == null )     return sVal ;
	if ( sFormat.length == 0 ) return sVal ;

	//var sVal               = oField.value ;			// Valeur originale du champ 
	var sSigne             = "" ;  					// Signe de la valeur originale
	var sUnsignedVal       = "" ;   				// Valeur originale sans le signe
	var sUnsignedValBefore = "" ;  					// Valeur originale sans le signe avant le point
	var sUnsignedValAfter  = "" ; 					// Valeur originale sans le signe apres le point
	
	var iNbBefore          = 0;						// Nombre de chiffre avant le point dans le champs
	var iNbAfter           = 0;						// Nombre de chiffre aprs le point dans le champs
	//var iDotPosition       = GetDotPosition( oField.value );	// Position du point dans le champs
	var iDotPosition       = GetDotPosition( sVal );	// Position du point dans le champs
	
	var iNbBeforeFormat    = 0;						// Nombre de chiffre avant le point dans le format
	var iNbAfterFormat     = 0;						// Nombre de chiffre aprs le point dans le format
	var iDotPositionFormat = GetDotPosition( sFormat );			// Position du point dans le format
	var sUnsignedValFormat = "" ; 					// Valeur originale sans le signe dans le format
	
	var sNewVal            = "";  						// Valeur formate
	
	if ( iDotPositionFormat == -1 )
	{
		alert("ERROR \n function fwkFormatNum() : \n Invalid Format ["+ sFormat +"]");
		return sVal ;
	} 
	
		//--- Sparation du signe et de la valeur non signe du champ 
		sSigne  = sVal.charAt(0) ; // Aprs controle de validit, le signe (s'il existe) est forcment au dbut
		if ( ( sSigne == "-" ) || ( sSigne == "+" ) )  
		{
			sUnsignedVal = sVal.substr(1) ;
			iDotPosition--;
		}
		else
		{
			sSigne = "+" ; // par dfaut 
			sUnsignedVal = sVal ;
		}
		//alert ( "sSigne = "+ sSigne +"\nsUnsignedVal = "+ sUnsignedVal +"\niDotPosition = "+ iDotPosition ) ;
		
		//--- Sparation du signe et de la valeur non signe du format
		sSigneFormat  = sFormat.charAt(0) ; // Aprs controle de validit, le signe (s'il existe) est forcment au dbut
		if ( ( sSigneFormat == "-" ) || ( sSigneFormat == "+" ) )  
		{
			sUnsignedValFormat = sFormat.substr(1) ;
			iDotPositionFormat--;
		}
		else
		{
			sSigneFormat = "+" ; // par dfaut 
			sUnsignedValFormat = sFormat ;
		}
		//alert ( "sSigneFormat = "+ sSigneFormat +"\nsUnsignedValFormat = "+ sUnsignedValFormat +"\niDotPositionFormat = "+ iDotPositionFormat ) ;
		
		//--- Nombre de chiffre avant et aprs le point dans le format
		iNbBeforeFormat = iDotPositionFormat;
		iNbAfterFormat  = ( sUnsignedValFormat.length - iDotPositionFormat - 1);
		
		//alert ( "Format:\niNbBeforeFormat = "+ iNbBeforeFormat +"\niNbAfterFormat = "+ iNbAfterFormat ) ;
		
		// S'il y a un point dans le champ
		if ( iDotPosition > -1 ){
			//--- Nombre de chiffre avant et aprs le point dans le champ
			iNbBefore = iDotPosition;
			iNbAfter  = ( sUnsignedVal.length - iDotPosition - 1);
			//alert ( "Champ:\niNbBefore = "+ iNbBefore +"\niNbAfter = "+ iNbAfter ) ;
						
			sUnsignedValBefore = sUnsignedVal.substr(0, iNbBefore);
			if (iNbBeforeFormat >= iNbBefore){
				for( i=0; i < (iNbBeforeFormat-iNbBefore); i++){
					sUnsignedValBefore = "0"+ sUnsignedValBefore;
				}	
			}
			//alert (sUnsignedValBefore);
		
			sUnsignedValAfter = sUnsignedVal.substr(iDotPosition+1, iNbAfter);
			if (iNbAfterFormat >= iNbAfter){
				for( i=0; i < (iNbAfterFormat-iNbAfter); i++){
					sUnsignedValAfter = sUnsignedValAfter +"0";
				}
			}else
			{
				sUnsignedValAfter=sUnsignedValAfter.substr(0,iNbAfterFormat) ;
			}
			
			//alert (sUnsignedValAfter);
		}
		else {
			//--- Nombre de chiffre avant et aprs le point dans le champ
			iNbBefore = sUnsignedVal.length;
			iNbAfter  = 0;
			//alert ( "Champ:\niNbBefore = "+ iNbBefore +"\niNbAfter = "+ iNbAfter ) ;
			
			sUnsignedValBefore = sUnsignedVal.substr(0, iNbBefore);
			if (iNbBeforeFormat >= iNbBefore){
				for( i=0; i < (iNbBeforeFormat-iNbBefore); i++){
					sUnsignedValBefore = "0"+ sUnsignedValBefore;
				}	
			}
			//alert (sUnsignedValBefore);
		
			for( i=0; i < (iNbAfterFormat - iNbAfter); i++){
				sUnsignedValAfter = sUnsignedValAfter +"0";
			}
			//alert (sUnsignedValAfter);
		}
		
		sNewVal = sUnsignedValBefore +"."+ sUnsignedValAfter		
		
		//--- Mise en place du signe (si ncessaire)
		if ( sFormat.indexOf("+") >= 0 ) // On veut toujours un signe ( + ou - )
		{
			sNewVal = sSigne + sNewVal ;
		}
		else if ( sFormat.indexOf("-") >= 0 ) // On veut un signe uniquement si ngatif ( - )
		{
			if  ( sSigne == "-" ) sNewVal = sSigne + sNewVal ; // On garde le "-" 
		}
		else  // Aucune exigence au niveau du format 
		{
			if  ( sSigne == "-" ) sNewVal = sSigne + sNewVal ; // On garde que le signe "-" 
		}

		//--- Affectation de la valeur formate dans le champ de saisie
		//oField.value = sNewVal ;
		return sNewVal ;
}
//------------------------------------------------------------------------
// Retourne la position du point dans le format
// 		retourne -1 si format invalide (pas de point ou plus de 1 point)
//------------------------------------------------------------------------
function GetDotPosition(sFormat)
{
	var iPos = null;							// Positon du point dans le format 
	var iNbPoint = 0;							// Nombre de point dans le format
	
	for ( i=0; i < sFormat.length; i++)
	{
		if ( sFormat.charAt(i) == "." )
		{
			iPos = i;
			iNbPoint++;
		}
	}
	
	if ( iNbPoint != 1 ) return -1;
	else return iPos;
}

//==============================================================================
//    
//==============================================================================

//------------------------------------------------------------------------
// setFocus() : Selectionne le champ avec la methode select() 
//              quand c'est possible sinon execute la methode focus()
//------------------------------------------------------------------------
function fwkSetFieldFocus( oHtmlObject ){
		if ( oHtmlObject != null ){
		try {
			oHtmlObject.select();
		}
		catch(e) {
			oHtmlObject.focus();
		}
	}
}



//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
// OLD Fonctions 
//------------------------------------------------------------------------
/***
var CaractereDecimal =".";

//------------------------------------------------------------------------
function FormatNum(Chp,NbDecimal) 
{
  if (Chp.value.length == 0) { return true;} // Champ vide
  // Controle de params pour debug :
  // if (arguments.length < 2) { alert('fonction FormatNum : Nombre incorrect de paramtres');return false;} 
  
  if (NombreCaractereDecimal(Chp.value) == 0) { Chp.value = Chp.value + CaractereDecimal ; }
  var i,j = 0;
  i = (Chp.value.length - Chp.value.indexOf(CaractereDecimal) - 1); // Nb chiffres aprs marque dcimale
  for ( j = i ; j < NbDecimal ; j++)
    { Chp.value = Chp.value + "0";}

  return true;
}
***/

//------------------------------------------------------------------------

//------------------------------------------------------------------------
//        F I N 
//------------------------------------------------------------------------

//------------------------------------------------------------------------------
// fwkScreen.js
//------------------------------------------------------------------------------
// Needs : 
// - fwkFields.js : fwkFilter(), fwkResetFieldErrorStatus(), fwkSetFieldShallowCheckingStandardColor()
// - fwkTools.js : xmlString()
//------------------------------------------------------------------------------
// Version : 3.0 ( 25/10/2005 )
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "Date" fields ( cf. RegisterFieldDate )
//----------------------------------------------------------------------
function fwkFieldDateGetValue() // Return the current field value in ISO format
{
	var sRet = null ;
	//alert("fwkFieldDateGetValue() : " + this.value );
	if ( this.dateValue == null ) 
	{
		alert ( "ERROR on Date field : dateValue object is null ! " );
		return null ;
	}
		
	if ( this.value == null ) 
	{
		sRet = "";
	}
	else if ( this.value.length == 0 ) 
	{
		sRet = "";
	}
	else
	{
		//--- Convert from field format to ISO format
		try {
			//--- Set the date format as the specific field format
			this.dateValue.setFormat(this.format);
			//--- Try to set the field value in the SimpleDate object
			this.dateValue.setDate(this.value);
			//--- Return the date in ISO format
			sRet = this.dateValue.format("YYYY-MM-DD");
		}
		catch (ex) {
			alert ( "ERROR : invalid date " + this.value ) ;
			sRet = null ;
		}
	}
	return sRet ;
/**
	try {
		//--- Build a date in the field format 
		var date = new SimpleDate(this.value , this.format );
		//--- Return the date in ISO format
		date.format("YYYY-MM-DD");
		
		// Re affect the current value to check the validity
		//this.date.setDate( this.value ); 
		// Return the ISO format of the date
		//return this.date.format("YYYY-MM-DD");
	}
	catch (ex) {
		alert ( "ERROR : invalid date " + this.value ) ;
		return null ;
	}
**/
}
//----------------------------------------------------------------------
function fwkFieldDateSetValue(sDateIso)
{
/**
	try {
		//--- Build a date in ISO format 
		var date = new SimpleDate(sDateIso, "YYYY-MM-DD");
		//--- Set the field value with its format 
		this.value = date.format( this.format );
	}
	catch (ex) {
		alert ( "ERROR : invalid date " + this.value ) ;
		return null ;
	}
**/
	var sRet = null ;
	//alert("fwkFieldDateSetValue( " + sDateIso + " )");
	if ( this.dateValue == null ) 
	{
		alert ( "ERROR on Date field : dateValue object is null ! " );
		return ;
	}
	if ( sDateIso == null ) 
	{
		this.value = "";
	}
	else if ( sDateIso.length == 0 ) 
	{
		this.value = "";
	}
	else
	{
		//--- Convert from ISO format to field format 
		try {
			//--- Set the date format as ISO format
			this.dateValue.setFormat("YYYY-MM-DD");
			//alert("fwkFieldDateSetValue : date format = " + this.dateValue.getFormat() + " )");
			//--- Try to set the date value (in ISO format)
			//this.dateValue.show();
			this.dateValue.setDate(sDateIso);
			//this.dateValue.show(); 
			//--- Re-format the date in the specific field format
			sRet = this.dateValue.format(this.format);
		}
		catch (ex) {
			alert ( "ERROR : invalid date " + this.value ) ;
			sRet = null ;
		}
		this.value = sRet ;
	}
}

//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "CheckBox" fields ( cf. RegisterCheckBox )
//----------------------------------------------------------------------
function fwkCheckboxGetValue()
{
	if ( this.checked ) return this.valueChecked ;
	else return this.valueUnchecked ;
}
//----------------------------------------------------------------------
function fwkCheckboxSetValue(sVal)
{
	if ( sVal == this.valueChecked ) this.checked = true ;
	else this.checked = false ;
}

//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "RadioGroup" fields ( cf. RegisterRadioGroup )
//----------------------------------------------------------------------
function fwkRadioGroupGetValue()
{
	var oRadio = null ;
	//--- For each "radio" object registered in this "radio group" 
	for ( var i = 0 ; i < this.aRadios.length ; i++ )
	{
		oRadio = this.aRadios[i] ;
		if ( oRadio == null )
		{
			alert("ERROR : fwkRadioGroupGetValue() : Radios ["+i+"] is null ! " );
		}
		else
		{
			if ( oRadio.checked ) return oRadio.value ;
		}
	}
	//--- No radio selected in this group
	return null ;
}
//----------------------------------------------------------------------
function fwkRadioGroupSetValue(sVal)
{
	var oRadio = null ;
	//--- For each "radio" object registered in this "radio group" 
	for ( var i = 0 ; i < this.aRadios.length ; i++ )
	{
		oRadio = this.aRadios[i] ;
		if ( oRadio == null )
		{
			alert("ERROR : fwkRadioGroupSetValue() : Radios ["+i+"] is null ! " );
		}
		else
		{
			if ( sVal == oRadio.value ) 
			{
				oRadio.checked = true ;
			}
			else
			{
				oRadio.checked = false ;
			}
		}
	}
}
//----------------------------------------------------------------------

//------------------------------------------------------------------------------
// "ScreenField" object
//------------------------------------------------------------------------------
function ScreenField(argFieldId, argFieldObject, argScreenZone, argXmlTag, argXmlAttr)
{
	//alert("ScreenField("+argFieldId+", ... ,"+ argScreenZone+","+ argXmlTag+","+ argXmlAttr+")" );
	if ( argFieldId == null )
	{
		throw new Error("ScreenField constructor : Field ID is null" );
		//alert ( "ERROR : ScreenField constructor : Field ID is null !" );
	}
	if ( argFieldObject == null )
	{
		throw new Error("ScreenField constructor : Unknown field with ID = " + argFieldId );
		//alert ( "ERROR : ScreenField constructor : Unknown field with ID = " + this.sId  );
	}

	//==============================================================================
	// PUBLIC ATTRIBUTES
	//==============================================================================
	this.sId      = argFieldId ; // cannot be null 
	this.oField   = argFieldObject; // cannot be null 
	this.sZone    = argScreenZone ;
	this.sXmlTag  = argXmlTag ; // can be null (if no XML mapping)
	this.sXmlAttr = argXmlAttr ; // can be null (if no XML mapping)
}

//------------------------------------------------------------------------------
// "XmlTags" object
//------------------------------------------------------------------------------
// Extensible collection indexed by "tag name" (as "Java Hashtable")
// For each tag name, hold a string with the attributes
// Example : 
// ["book"]   -> " id='3' price='12' "
// ["author"] -> " name='Zola' "
//------------------------------------------------------------------------------
function XmlTags()
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _oTags   = new Object();  // The "HashTable" (void)
	
	//==============================================================================
	// PUBLIC METHODS 
	//==============================================================================

	this.addField = function(sTag, sAttr, sValue) // Add an attribute for this tag
	{
		var sToAdd = " " + sAttr + "=\"" + Tools.xmlString(sValue) + "\"" ;
		var sCurrent = _oTags[sTag] ;
		if ( sCurrent == null )
		{
			_oTags[sTag] = sToAdd ;
		}
		else
		{
			_oTags[sTag] = sCurrent + sToAdd ;
		}
	}
	
	//------------------------------------------------------------------------------
	
	this.getXmlTags = function() // Get all the tags (one line per XML tag)
	{
		var sXml = "" ;
		for ( tag in _oTags )
		{
			sXml += "<" + tag + _oTags[tag] + "/>\n" ;
		}
		return sXml ;
	}
}

//------------------------------------------------------------------------------
// "Screen" Object 
//------------------------------------------------------------------------------
function Screen(argScreenName, argAjaxUrl, argScreenId )
{
	//alert ( "CONTRUCTOR : Screen()" );
	if ( argScreenName == null ) alert ( "ERROR: Screen() constructor : 1st argument is null ( Screen Name )" ) ;
	if ( argAjaxUrl  == null ) alert ( "ERROR: Screen() constructor : 2nd argument is null ( Ajax URL )" ) ;
	if ( argScreenId == null ) argScreenId = 0 ;

	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	//--- The name of the screen
	var _sScreenName       = argScreenName ;

	//--- The URL used to send the requests
	var _sUrlBase          = argAjaxUrl ;

	//--- The ScreenContext ID in the ScreenSession
	var _iScreenId         = argScreenId ;	 

//alert ("Screen constructor : Screen Id = " + _iScreenId );

	var _oInvalidField     = null ;

	//--- The ScreenFields Array ( Filled by "RegisterField()" )
	var _aScreenFields     = new Array() ; 

	//--- The registered screen fields serialized in XML format
	var _sSerializedFields = "" ;
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	
	//------------------------------------------------------------------------------
	// Serialize all the registered fields (in XML format) 
	//------------------------------------------------------------------------------
	function _serializeFields ()
	{
		//alert("_serializeFields()");

		var oXmlTags = new XmlTags();
		var oScreenField = null ;
		var oField = null ;
		var sFieldValue = null ;

		//--- For each field registered in this screen 
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField == null )
			{
				alert("ERROR : serializeFields() : ScreenField ["+i+"] is null ! " );
			}
			else
			{
				//--- If the field is mapped to an XML attributue 
				if (  oScreenField.sXmlTag != null && oScreenField.sXmlAttr != null )
				{
					oField = oScreenField.oField ;
					if ( oField == null )
					{
						alert("ERROR : serializeFields() : Field ["+i+"] is null ! " );
					}
					else
					{
						sFieldValue = null ;
						if ( oField.getValue )
						{
							sFieldValue = oField.getValue() ;
						}
						else
						{
							sFieldValue = oField.value ;
						}
						oXmlTags.addField(oScreenField.sXmlTag, oScreenField.sXmlAttr, sFieldValue );
					}
				}
			}
		}
		_sSerializedFields = oXmlTags.getXmlTags() ;
		return _sSerializedFields ;
	}
	//------------------------------------------------------------------------------
	// Populate all the registered fields from the response object
	//------------------------------------------------------------------------------
	//function _populateFields ( oScreen, response )
	function _populateFields ( response )
	{
		//alert("_populateFields(response) " );
		
		var oScreenField = null ;
		var oField = null ;
		var sFieldValue = null ;
		
		//--- For each field registered in this screen 
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			//oScreenField = oScreen.aScreenFields[i] ;
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField == null )
			{
				alert("ERROR : _populateFields() : ScreenField ["+i+"] is null ! " );
			}
			else
			{
				//--- If the field is mapped to an XML attributue 
				if (  oScreenField.sXmlTag != null && oScreenField.sXmlAttr != null )
				{
					oField = oScreenField.oField ;
					if ( oField == null )
					{
						alert("ERROR : _populateFields() : Field ["+i+"] is null ! " );
					}
					else
					{
						sFieldValue = response.getXmlValue ( oScreenField.sXmlTag, oScreenField.sXmlAttr ) ;
						if ( oField.setValue ) 
						{
							oField.setValue(sFieldValue) ;
						}
						else
						{
							oField.value = sFieldValue ;
						}
						//oField.value = response.getXmlValue ( oScreenField.sXmlTag, oScreenField.sXmlAttr ) ;
					}
				}
			}
		}
	}
	//------------------------------------------------------------------------------
	this.getScreenName = function()
	{
		return _sScreenName ;
	}
	//------------------------------------------------------------------------------
	this.getScreenId = function()
	{
		return _iScreenId ;
	}
	//------------------------------------------------------------------------------
	this.getRequestURL = function() 
	{
		return _sUrlBase ;
	}
	//------------------------------------------------------------------------------
	
	//------------------------------------------------------------------------------
	// METHODE : ScreenToXml
	//------------------------------------------------------------------------------
	this.ScreenToXml = function()
	{
		//alert ( "ScreenToXml()" );
		var sRet = null ;
		//--- Partie standard de l'cran
    	//if ( this.aScreenFields.length > 0 ) 
    	if ( _aScreenFields.length > 0 ) 
    	{
    		//sRet = _serializeFields(this);
    		sRet = _serializeFields();
    		//alert(sRet);
    	}
		return sRet ;
		
		/**
		//--- Partie "dtail" de l'cran (si elle existe)
		if ( this.oDetail != null ) 
		{
			this.oDetail.ScreenToXml() ;
		}
		**/
	}

	//------------------------------------------------------------------------------
	// METHODE : XmlToScreen
	//------------------------------------------------------------------------------
	this.XmlToScreen = function(response)
	{
		//alert ( "XmlToScreen()" );
		if ( response.dataNotFound() )
		{
			//alert("Data not found.");
		}
		else
		{
			//--- Partie standard de l'cran
	    	if ( _aScreenFields.length > 0 ) 
	    	{
	    		_populateFields(response);
				/**
				//--- Partie "dtail" de l'cran (si elle existe)
				if ( this.oDetail != null ) 
				{
					this.oDetail.ScreenToXml() ;
				}
				**/
	    	}
		}		
	}

	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.RegisterField = function(sFieldId, sScreenZone, sXmlTag, sXmlAttr )
	{
		// alert("RegisterField(" + sFieldId +"," + sScreenZone + "," + sXmlTag + "," + sXmlAttr + ")...");
		if ( sFieldId == null ) 
		{
			alert("ERROR: RegisterField : no field id !");
			return null ;
		}
		var oField = null ;
		try {
			oField = document.getElementById(sFieldId);
			if ( oField )
			{
				var oScreenField = new ScreenField(sFieldId, oField, sScreenZone, sXmlTag, sXmlAttr);
	    		_aScreenFields.push( oScreenField );
			}
			else
			{
				alert("ERROR: RegisterField : Object with id " + sFieldId + " not found ! " ) ;
			}
		} catch ( e ) {
			alert ( "ERROR: Exception in RegisterField()! \n" + e.message ) ;
		}
    	return oField ;
	}
	//------------------------------------------------------------------------------
	this.RegisterFieldDate = function(sId, sScreenZone, sXmlTag, sXmlAttr, sFormat )
	{
		//alert("RegisterFieldDate(" + sId +"," + sScreenZone + "," + sXmlTag + "," + sXmlAttr + ")...");
		try {			
			var obj = this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
			if ( obj )
			{
				obj.getValue  = fwkFieldDateGetValue ;
				obj.setValue  = fwkFieldDateSetValue ;
				obj.format    = sFormat ;
				obj.dateValue = new SimpleDate(null, sFormat);
			}
		}
		catch (ex) {
			alert ( "ERROR in RegisterFieldDate : \n" + ex.message ) ;
		}
	}
	//------------------------------------------------------------------------------
	this.RegisterCheckBox = function(sId, sScreenZone, sXmlTag, sXmlAttr, sValOn, sValOff )
	{
		//alert("RegisterCheckBox(" + sId +"," + sScreenZone + "," + sXmlTag + "," + sXmlAttr + ")...");
		try {			
			var obj = this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
			if ( obj )
			{
				obj.valueChecked   = sValOn ;
				obj.valueUnchecked = sValOff ;
				obj.getValue = fwkCheckboxGetValue ;
				obj.setValue = fwkCheckboxSetValue ;
			}
		}
		catch (ex) {
			alert ( "ERROR in RegisterCheckBox : \n" + ex.message ) ;
		}
	}
	//------------------------------------------------------------------------------
	this.RegisterRadioGroup = function(sId, sScreenZone, sXmlTag, sXmlAttr, aRadioIds )
	{
		//alert("RegisterRadioGroup(" + sId +"," + sScreenZone + "," + sXmlTag + "," + sXmlAttr + "," + aRadioIds + ")...");
		try {			
			var obj = this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
			if ( obj )
			{
				//--- Build the "Radio" objects array 
				var aRadios = new Array();
				var oRadio = null ;
				var iRadio = 0 ;
				for ( var i = 0 ; i < aRadioIds.length ; i++ )
				{
					oRadio = document.getElementById( aRadioIds[i] ) ;
					if ( oRadio != null )
					{
						aRadios[iRadio++] = oRadio ;
					}
					else
					{
						alert ( "ERROR: Radio object not found !  id = " + aRadioIds[i] );
					}
				}
				obj.aRadios = aRadios ;
				//--- Set new methods 
				obj.getValue = fwkRadioGroupGetValue ;
				obj.setValue = fwkRadioGroupSetValue ;			
			}
		}
		catch (ex) {
			alert ( "ERROR in RegisterRadioGroup : \n" + ex.message ) ;
		}
	}
			
	//------------------------------------------------------------------------------
	// Clear a specific field passed by reference (object)
	//------------------------------------------------------------------------------
	this.ClearField = function ( oField ) // RET : void 
	{
		//var sType = oField.getAttribute("type") ;
		var sType = oField.type ;
		switch ( sType )
		{
			case "text" :
			case "file" : 
			case "password" : 
			case "textarea" : 
				oField.value = "" ;
				/**
				// fwkResetFieldErrorStatus(oField); #TODO ????
				try {
					// Option par dfaut (si elle existe)
					if ( oField.fwkDefaultValue != null ) // Par valeur
					{
						oField.value = oField.fwkDefaultValue ;
					}
  				} catch ( ex ) { 
					oField.value = "" ;
  				} 
  				**/
				break ;
					
			case "select-one" : 
			case "select-multiple" :
				oField.selectedIndex = -1 ; // Aucune ligne slectionne (OK / IE & Firefox)
				/**
				try {
					// Option par dfaut (si elle existe)
					if ( oField.fwkDefaultValue != null )	   // Par valeur
					{
						oField.value = oField.fwkDefaultValue ;
					}
					else if ( oField.fwkDefaultIndex != null ) // Par index
					{
						oField.selectedIndex = oField.fwkDefaultIndex ;
					}
  				} catch ( ex ) { 
	  				oField.selectedIndex = -1 ; 
  				} 
  				**/
				break ;

			case "checkbox" : 
			case "radio" :
				oField.checked = false ;
				break ;
		}
		
		if ( sType == null )
		{
			// alert ( "Type is null" );
			// if type is null => it's a radio buttons container 
			var elements = oField.getElementsByTagName("input") ; 
			if ( elements != null )
			{
				for ( var i=0 ; i < elements.length ; i++ )
				{
					//alert ( "element["+i+"] : type = " + elements[i].type );
					if ( elements[i].type == "radio" )
					{
						elements[i].checked = false  ;					
					}
				}			
			}
			/**
			else
			{
					alert ( "no elements <input>" );
			}
			**/
		}
	}
	//------------------------------------------------------------------------------
	// Clear the entire screen or a specific zone 
	// sZone arg can be null 
	//------------------------------------------------------------------------------
	this.Clear = function ( sZone ) // RET : void 
	{
		//alert("Clear() : sZone = " + sZone );
		var oScreenField = null ;
		var oField = null ;

		//--- For each field registered in this screen 
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField == null )
			{
				alert("ERROR : Clear() : ScreenField ["+i+"] is null ! " );
			}
			else
			{
				oField = oScreenField.oField ;
				if ( oField == null )
				{
					alert("ERROR : Clear() : Field ["+i+"] is null ! " );
				}
				else
				{
					if ( sZone == null )
					{
						//alert("Clear() : field " + i + " - field.type = " + oField.type );
						this.ClearField(oField);
					}
					else 
					{
						if ( oScreenField.sZone == sZone )
						{
							this.ClearField(oField);
						}
					}
				}			
			}
		}	
	}
		
	//------------------------------------------------------------------------------
	// METHODE : Desc
	//------------------------------------------------------------------------------
	this.Desc = function()
	{
		alert ( "SCREEN OBJECT : \n" +
				"\n . Screen-Name = " + _sScreenName + 
				"\n . Screen-Id (Popup Level) = " + _iScreenId +
				"\n . UrlBase = " + _sUrlBase + 
				"\n . " + _aScreenFields.length + " field(s) " );
	}

	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	// METHODE : Traitements standards pour l'vnement "window.onLoad" 
	//------------------------------------------------------------------------------
	this.OnLoad = function () // RET : void
	{
		this.New();
		this.printMessage();
	}


	//------------------------------------------------------------------------------
	this.Exit = function()
	{
		//--- On essaye de fermer l'cran
		try {
			this.close();
		}
		catch (e) {}

		//--- Si l'cran n'a pas t ferm on rinitialise l'cran
		this.New();
		this.printMessage();
	}
	//------------------------------------------------------------------------------
	this.close = function()
	{
		//--- Ecran popup
		if ( _iScreenId > 0 )
		{
			//--- On sort de l'cran
			window.close();
		}
		//--- Premier champ de l'cran
		else 
		{
			try
			{
				//--- On ouvre la page d'accueil
				document.location.href = PageAccueil;
			} catch (e) {}
		}
	}
	//------------------------------------------------------------------------------

	//==============================================================================
	//  GESTION DES CHAMPS ( KeyFields et DataFields ) : Disable / Clear / Check
	//==============================================================================

	//------------------------------------------------------------------------------
	// Fonction de vrification d'UN champ
	//------------------------------------------------------------------------------
	this.CheckField = function ( oField ) // RET : boolean : true = OK / false = NOK 
	{
		//--- Champ NOT NULL -------------------------------------------------------
		if ( oField.getAttribute("fwkNotNull") )
		{
			// alert ( "Check field ( id = " +oField.id+ " ) : attribute fwkNotNull found." ) ;
			switch ( oField.getAttribute("type") )
			{
				case "text" :       // Tag "input type=text "
				case "file" :
				case "password" :
				case "textarea" :   // Tag "textarea "
				case "select-one" : // Tag "select"
				// case "checkbox" :  // Not Null n'a pas de sens pour une "Check Box"
				// case "radio" :     // Not Null n'a pas de sens pour un  "Radio Button"
					if ( oField.value == null || oField.value == "" ) 
					{
						_oInvalidField = oField ;
						var memoColor = oField.style.backgroundColor ;
						oField.style.backgroundColor = 'orange' ;
						alert ( "The field "+oField.name+ " ( id = " +oField.id+ " ) is required " );
						oField.style.backgroundColor = memoColor ;
						return false ;
					}
					break ;
			}
		}
		//--- Champ dans l'tat VALEUR INCORRECTE ---------------------------------- 
		// if ( oField.style.backgroundColor == 'red' )  // Modif Ver 2.6
		if ( fwkIsFieldOnError(oField) || fwkIsFieldOnShallowCheckingError(oField) ) // Ver 2.6
		{
			_oInvalidField = oField ;
			//alert ( "There is an invalid field (at least) !" );
			return false ;
		}
		return true ;
	}


	//------------------------------------------------------------------------------
	// Fonction de vrification de l'ensemble des champs
	// ( La sortie du champ ventuellement en cours de saisie est force 
	// au niveau de la gestion des touches de fonctions )
	//------------------------------------------------------------------------------
	this.CheckAllFields = function () // RET : boolean : true = OK / false = NOK
	{
		//for ( var i = 0 ; i < this.aScreenFields.length ; i++ )
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			//if ( this.CheckField(this.aScreenFields[i]) == false ) return false ;
			if ( this.CheckField(_aScreenFields[i]) == false ) return false ;
		}

		//--- A ce stade tous les champs sont OK 
		_oInvalidField = null ;
		return true ; 
	}

	//==============================================================================
	//  ACTIONS UTILISATEUR 
	//==============================================================================

	//------------------------------------------------------------------------------
	// Triggers : A SURCHARGER SI NECESSAIRE
	//------------------------------------------------------------------------------
	this.beforeSelect = function () { return true ; }
	this.afterSelect  = function () { return ; }
	this.beforeUpdate = function () { return true ; }
	this.afterUpdate  = function () { return ; }
	this.beforeInsert = function () { return true ; }
	this.afterInsert  = function () { return ; }
	this.beforeDelete = function () { return true ; }
	this.afterDelete  = function () { return ; }

}





//------------------------------------------------------------------------------
// fwkScreenRequest.js
//------------------------------------------------------------------------------
// Version : 1.0  ( 12/12/2005 )
// Author  : Laurent Gurin 
// Changes : none (creation)
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenRequest( )
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _bTrace  = false ;
	
	var _sScreenName = null ;
	var _sScreenId   = null ;
	var _sAction     = null ;
	var _sProcedure  = null ;
	
	var _sFlagGet    = null ;
	var _sFlagSet    = null ;
	var _sFlagClear  = null ;
	
	var _oParameters = new Object();

	var _sDataTags   = null ;
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE : \n\n" + sMsg ) ;
	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.setScreenName = function ( s ) 
	{
		_sScreenName = s ;
	}
	//------------------------------------------------------------------------------
	this.setScreenId = function ( s ) 
	{
		_sScreenId = s ;
	}
	//------------------------------------------------------------------------------
	this.setAction = function ( s ) 
	{
		_sAction = s ;
	}
	//------------------------------------------------------------------------------
	this.setProcedure = function ( s ) 
	{
		_sProcedure = s ;
	}
	//------------------------------------------------------------------------------
	this.setFlagGet = function ( s ) 
	{
		_sFlagGet = s ;
	}
	//------------------------------------------------------------------------------
	this.setFlagSet = function ( s ) 
	{
		_sFlagSet = s ;
	}
	//------------------------------------------------------------------------------
	this.setFlagClear = function ( s ) 
	{
		_sFlagClear = s ;
	}
	//------------------------------------------------------------------------------
	this.setParameter = function ( sName, sValue ) 
	{		
		_trace ( "setParameter : " + sName + "=" + sValue ) ;
		if ( sName == null )
		{
			alert ( "ERROR: setParameter() : name = null" );
			return ;
		}
		if ( sValue == null )
		{
			alert ( "ERROR: setParameter() : value = null" );
			return ;
		}
		_oParameters[sName] = sValue ;
	}
	//------------------------------------------------------------------------------
	this.clearParameters = function () 
	{		
		_trace ( "clearParameters " ) ;
		_oParameters = new Object(); ;
	}
	//------------------------------------------------------------------------------
	this.showParameters = function () 
	{
		var sParams = "PARAMETERS : \n" ;
		for ( p	in _oParameters )
		{
			sParams += p + "=" + _oParameters[p] + "\n" ;
		}
		alert( sParams ); 
	}

	//------------------------------------------------------------------------------
	// Data XML Tags ( to be inserted between <data> and </data> )
	//------------------------------------------------------------------------------
	this.setData = function ( s ) 
	{
		_trace ( "setData() : \n" + s ) ;
		_sDataTags = s ;
	}
	//------------------------------------------------------------------------------
	this.clearData = function ( s ) 
	{
		_trace ( "clearData()" ) ;
		_sDataTags = null ;
	}
	//------------------------------------------------------------------------------
	this.showData = function () 
	{
		alert ( "DATA : \n" + _sDataTags ) ;
	}
		
	//------------------------------------------------------------------------------
	// Build and return the XML Request
	//------------------------------------------------------------------------------
	this.getXmlRequest = function () 
	{
		var sXml = "<request " 
			+ " screen-name=\"" + _sScreenName + "\" " 
			+ " screen-id=\""   + _sScreenId   + "\" " 
			+ " action=\""      + _sAction     + "\" " ;
		if ( _sAction.toLowerCase() == "exec" ) 
		{
			if ( _sProcedure != null ) 
			{
				sXml += " proc-name=\"" + _sProcedure + "\" " ;
			}
			else
			{
				alert("WARNING : action 'exec' without procedure name ! ");
			}
		}
		if ( _sFlagGet != null ) 
		{
			sXml += " get=\"" + _sFlagGet + "\" " ;
		}
		if ( _sFlagSet != null ) 
		{
			sXml += " set=\"" + _sFlagSet + "\" " ;
		}
		if ( _sFlagClear != null ) 
		{
			sXml += " clear=\"" + _sFlagClear + "\" " ;
		}		
		sXml += " > \n" ;

		//--- Parameters list 
		var sParams = "" ;
		var iParamsCount = 0 ;
		for ( p	in _oParameters )
		{
			sParams += "<param " + p + "=\"" + _oParameters[p] + "\" />\n" ;
			iParamsCount++ ;
		}
		if ( iParamsCount > 0 ) 
		{
			sXml += "<params>\n" ;
			sXml += sParams ;
			sXml += "</params>\n" ;			
		}
		
		//--- Data Tags ( 1 to N )
		if ( _sDataTags != null )
		{
			sXml += "<data>\n" ;
			sXml += _sDataTags ;
			sXml += "</data>\n" ;						
		}
		
		//--- End of requet
		sXml += "</request>\n" ;
		
		_trace( "getXmlRequest() : \n" + sXml ); 
		return sXml ;
	}
	
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// fwkScreenResponse.js
//------------------------------------------------------------------------------
// Version : 1.0  ( 12/12/2005 )
// Author  : Laurent Gurin 
// Changes : none (creation)
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenResponse( oXmlHttpRequest )
{
	//==============================================================================
	// STANDARD ATTRIBUTES & METHODS
	//==============================================================================
	var _sClassName = "ScreenResponse" ;
	var _bTrace = false ;
	//------------------------------------------------------------------------------
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE : [" + _sClassName + "] \n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	function _error ( sMsg ) 
	{
		alert ( "ERROR : [" + _sClassName + "] \n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _iReadyState     = oXmlHttpRequest.readyState ; // 1, .. , 4 (complete)
	var _iHttpStatusCode = oXmlHttpRequest.status ; // HTTP Status Code ( ie : "200" = "OK" )
	var _sHttpStatusText = oXmlHttpRequest.statusText ; // HTTP Status Text ( ie : "OK" )
	var _sResponseText   = oXmlHttpRequest.responseText ; // Response Body as text 
	var _oResponseXML    = oXmlHttpRequest.responseXML  ; // Response Body as XML Document (DOM tree)
	var _sReturnCode     = "" ; // Telosys Return Code ( ie : "0" for "OK" )
	var _sReturnMessage  = "" ; // Telosys Return Message 
	var _htValues        = null ; // Values hashtable : init by getValues()
	
	if ( _iReadyState != 4) // 4 = complete
	{
		//--- Error
		_error("Request state is NOT COMPLETE ( readyState = " + _iReadyState + " ) ");
	}
	else
	{
		if ( _iHttpStatusCode != 200 ) // 200 = OK
		{
			//--- Error
			_error("HTTP ERROR ( Status = " + _iHttpStatusCode + " - " + _sHttpStatusText + " ) ");
		}
		else
		{
			_initReturn() ;
		}
	}
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _initReturn() 
	{
		var tagReturn = _getXmlSingleTag("return");
		if ( tagReturn == null )
		{
			_error("No <return> tag in the response !");
		}
		else
		{
			//--- Get the "code" attribute
			try {
				var sRetCode = tagReturn.getAttribute("code") ;
				if ( sRetCode == null )
				{
					_sReturnCode = "" ;
					_error("No 'code' attribute in the <return> tag !");
				}
				else
				{
					_sReturnCode = sRetCode ;
				}
			} catch (e) {
				_error("Exception on getAttribute('code') in <return> tag !\nException : " + e.message );
			}
			
			//--- Get the "message" attribute
			try {
				var sRetMessage = tagReturn.getAttribute("message") ;
				if ( sRetMessage == null )
				{
					_sReturnMessage = "" ;
					_error("No 'message' attribute in the <return> tag !");
				}
				else
				{
					_sReturnMessage = sRetMessage ;
				}
			} catch (e) {
				_error("Exception on getAttribute('message') in <return> tag !\nException : " + e.message );
			}		
		}
	}
	//------------------------------------------------------------------------------
	function _getXmlSingleTag ( sTagName ) 
	{
		if ( _oResponseXML == null )
		{
			_error("_getXmlSingleTag(" + sTagName + ") : Xml response is null !");
			return null ;
		}
		var tag = null ;
		try {
			var allTags = _oResponseXML.getElementsByTagName( sTagName ) ;
			if ( allTags != null )
			{
				_trace ( "_getXmlSingleTag(" + sTagName + ") : " + allTags.length + " element(s)" );			
				//--- There is a single tag for this name so we take the first one
				tag = allTags.item(0) ;
			}
			else
			{
				_error("_getXmlSingleTag() : No tag <" + sTagName + "> in the XML response ! \n getElementsByTagName(..) return null !");
			}
		} catch (e) {
			_error("_getXmlSingleTag(" + sTagName + ") \nException : " + e.message );
		}
		if ( tag == null )
		{
			_error("No tag <" + sTagName + "> in the XML response !");
		}
		return tag ;
	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.isOK = function () 
	{
		if ( ( _iReadyState == 4 ) && ( _iHttpStatusCode == 200 ) && ( _sReturnCode == "0" ) ) 
		{
			return true ;
		}
		else
		{
			return false ;
		}
	}
	//------------------------------------------------------------------------------
	// Return the response as TEXT flow
	//------------------------------------------------------------------------------
	this.getResponseText = function () 
	{
		return _sResponseText ;
	}
	//------------------------------------------------------------------------------
	this.getResponseXML = function () 
	{
		return _oResponseXML ;
	}
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	this.getReadyState = function () 
	{
		return _iReadyState ;
	}
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	this.getHttpStatusCode = function () 
	{
		return _iHttpStatusCode ;
	}
	//------------------------------------------------------------------------------
	this.getHttpStatusText = function () 
	{
		return _sHttpStatusText ;
	}
	//------------------------------------------------------------------------------
	this.getReturnCode = function () 
	{
		return _sReturnCode ;
	}
	//------------------------------------------------------------------------------
	this.getReturnMessage = function () 
	{
		return _sReturnMessage ;
	}
	//------------------------------------------------------------------------------
	this.dataNotFound = function ()
	{
		//var tagReturn = this.getXmlSingleTag("return") ;
		var tagReturn = _getXmlSingleTag("return") ;
		if ( tagReturn != null )
		{
			//--- Get the given TAG  
			var tagNotFound = null ;
			try {
				tagNotFound = tagReturn.getElementsByTagName("not-found").item(0);
			} catch (e) {
				tagNotFound = null ;
			}
			return ( tagNotFound != null ? true : false ) ;
		}
		return false ;
	}
	//------------------------------------------------------------------------------
	this.dataFound = function ()
	{
		var tagReturn = _getXmlSingleTag("return") ;
		if ( tagReturn != null )
		{
			//--- Get the given TAG  
			var tagFound = null ;
			try {
				tagFound = tagReturn.getElementsByTagName("found").item(0);
			} catch (e) {
				tagFound = null ;
			}
			return ( tagFound != null ? true : false ) ;
		}
		return false ;
	}
	//------------------------------------------------------------------------------
	// Return true if <response> <data void="true" /> </response> 
	//------------------------------------------------------------------------------
	this.dataVoid = function ()
	{
		//alert( "ScreenResponse.dataVoid()..." );
		var bRet = false ;
		var tagData = _getXmlSingleTag("data") ;
		if ( tagData != null )
		{
			//--- Get the "void" attribute  
			var attribVoid = null ;
			try {
				attribVoid = tagData.getAttribute("void");
			} catch (e) {
				attribVoid = null ;
			}
			bRet = ( attribVoid != null ? true : false ) ;
		}
		else
		{
			//--- No tag <data> => VOID
			bRet = true ;
		}
		//alert( "ScreenResponse.dataVoid() : return = " + bRet  );
		return bRet ;
	}
	
	//------------------------------------------------------------------------------
	this.show = function () 
	{
		var sMsg = "RESPONSE : \n" ;
		sMsg += "Request state : " + _iReadyState + " ( 4 = complete ) \n" ;
		sMsg += "Http Status : " + _iHttpStatusCode + " - " + _sHttpStatusText + " \n" ;
		sMsg += "Response text : \n" + _sResponseText  ;
		/**
		for ( p	in this.oParameters )
		{
			sParams += p + "=" + this.oParameters[p] + "\n" ;
		}
		**/
		alert( sMsg ); 
	}
	//------------------------------------------------------------------------------
	this.getXmlTagData = function () 
	{
		var tagData = null ;
		try {
			var allTagsData = _oResponseXML.getElementsByTagName( "data" ) ;
			if ( allTagsData != null )
			{
				//--- There is a single tag <data> so we take the first one
				tagData = allTagsData.item(0) ;
			}
		} catch (e) {
			_error("getXmlTagData() \nException : " + e.message );
		}
		return tagData ;
	}
	//------------------------------------------------------------------------------
	this.getXmlValue = function ( sTag, sAttr ) 
	{
		if ( _oResponseXML == null )
		{
			_error("Xml response is null !");
			return null ;
		}
		//--- Get the tag <data>
		var tagData = _getXmlSingleTag("data") ;
		if ( tagData == null )
		{
			_error("No <data> in the response !");
			return null ;
		}		
		//--- Get the given TAG  
		var xmlTag = null ;
		try {
			xmlTag = tagData.getElementsByTagName(sTag).item(0);
		} catch (e) {
			xmlTag = null ;
		}
		if ( xmlTag == null )
		{
			//_trace(sTag+"." + sAttr + "\nTag not found.");
			return null ;
		}
		//--- Get the given ATTRIBUTE  
		try {
			var sRet = xmlTag.getAttribute(sAttr) ;
			//_trace(sTag+"." + sAttr + " = [" + sRet + "]" );
			/**
			if ( sRet != null )
			{
				_trace(sTag+"." + sAttr + "\nOK, found : [" + sRet + "]" );
			}
			else
			{
				_trace(sTag+"." + sAttr + "\nAttribute not found." );
			}
			**/
			return sRet ;
		} catch (e) {
			_error(sTag+"." + sAttr + "\nError on getAttribute() !\nException : " + e.message );
			return null ;
		}
		return null ;
	}

	//------------------------------------------------------------------------------
	this.getMessages = function () 
	{
		var tagReturn = _getXmlSingleTag("return") ;
		if ( tagReturn != null )
		{
			//--- Get the TAG  
			var tagMessages = null ;
			try {
				tagMessages = tagReturn.getElementsByTagName("messages").item(0);
			} catch (e) {
				tagMessages = null ;
			}
			if ( tagMessages != null )
			{
				//alert ( "<messages> found " ) ;
				messages = tagMessages.getElementsByTagName("message");
				if ( messages != null )
				{
					var msgList = [] ;
					var i = 0 ;
					var n = messages.length ;
					var msg = null ;
					//alert ( "nb messages = " + n ) ;
					var code = null ;
					var text = null ;
					var type = null ;
					for ( i = 0 ; i < n ; i++ )
					{
						msg = messages.item(i) ;
						try {
							code = msg.getAttribute("code");							
							text = msg.getAttribute("text");
							type = msg.getAttribute("type");
						} catch (e) {
							_error("getMessages() \nError on getAttribute() !\nException : " + e.message );
							return null ;
						}
						msgList[i] = new ScreenMessage(code, text, type);
						//alert ( "message " + i + " : " + msgList[i].toString() ) ;
					} 
					return msgList;
				}
			}
		}
		return null ;
	}
	//------------------------------------------------------------------------------
	// Return the value of the given value name
	// <values> <value-name value="xxx" /> </values>
	//------------------------------------------------------------------------------
	this.getValue = function ( sName ) 
	{
		var htValues = this.getValues();
		if ( htValues != null )
		{
			return htValues[sName];
		}
		return null ;
	}
	//------------------------------------------------------------------------------
	// Return all the values of the response ( hashtable )
	// <values> <value-name value="xxx" /> </values>
	//------------------------------------------------------------------------------
	this.getValues = function () 
	{
		if ( _htValues != null ) // if already loaded
		{
			return _htValues ; // return the existing hashtable
		}
		//--- Get the TAG  
		var tagValues = _getXmlSingleTag("values") ;
		if ( tagValues != null )
		{
			//alert ( "<values> found " ) ;
			try {
				var values = tagValues.getElementsByTagName("value");
				if ( values != null )
				{
					var htValues = new Object() ;
					var value = null ;
					var i = 0 ;
					var n = values.length ;
					//alert ( "nb values = " + n ) ;
					for ( i = 0 ; i < n ; i++ ) // for each tag <value>
					{
						value = values.item(i) ;
						if ( value.attributes != null )
						{
							if ( value.attributes.length > 0 )
							{
								// store in the Values HashTable 
								htValues[value.attributes[0].name] = value.attributes[0].value ;
							}								
						}
					} 
					if ( _htValues == null )
					{
						_htValues = htValues ;
					}
					return htValues;
				}
			} catch (ex) {
				_error("getValues() \n Exception : " + ex.message );
				return null ;
			}
		}
		return null ;
	}	
	//------------------------------------------------------------------------------
	this.showValues = function () 
	{
		var htValues = this.getValues();
		if ( htValues != null )
		{
			var s = "" ;
			for ( name in htValues )
			{
				s = s + "\n . " + name + " = " + htValues[name] ;
			}
			alert ( "Values : " + s ) ;
		}
		else
		{
			_error("No values in the response !");
		}	
	}
	//------------------------------------------------------------------------------
	this.getViewContent = function ()
	{
		var elements = _oResponseXML.getElementsByTagName( "view" );
		if ( elements == null )
		{
			//_error( "Tag <view> not found ( getElementsByTagName return null ) !" ) ; 
			return null ;
		}
		
		_trace ( elements.length + " <view> element(s)" );
		if ( elements.length < 1 )
		{
			//_error( "Tag <view> not found ( 0 elements )!" ) ; 
			return null ;
		}

		//--- There is a single tag for this name => take the first one
		var elementView = elements.item(0) ;
		if ( ! elementView.hasChildNodes() )
		{
			//_error( "Tag <view> is void ( no child nodes )!" ) ; 
			return null ;
		}
		
		_trace("Element <view> has " + elementView.childNodes.length + " child node(s)" );
		//--- Search the first CDATA-SECTION in the child nodes 
		for ( i = 0 ; i < elementView.childNodes.length ; i++ )
		{
			node = elementView.childNodes[i];
			//_trace ("Node [ " + i + " ] : name = " + node.nodeName + " type = " + node.nodeType + " value = " + node.nodeValue );
			if ( node.nodeType == 4 ) // Type 4 = "#cdata-section" / Type 3 = "#text"
			{
				_trace ("Node Content found : name = " + node.nodeName + " type = " + node.nodeType + " value = " + node.nodeValue );
				//--- Return the CDATA-SECTION content
				return node.nodeValue ;
			}
		}
		_error( "No CDATA section in the tag <view> !" ) ; 
	}
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// fwkScreenServices.js
//------------------------------------------------------------------------------
// Version : 1.0  ( 12/12/2005 )
// Author  : Laurent GUERIN 
// Changes : none (creation)
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenService( sServiceName, sRootUrl, fctProcessResponse ) 
{
	//--- Call the super constructor
	Ancestor.call(this, "ScreenService", false);
	var _this = this ;
	var _trace = this.trace ;
	var _error = this.error ;
	//------------------------------------------------------------------------------
	if ( arguments.length != 3 )
	{
		_error ( "Constructor : 3 arguments expected !" );
		return ;
	}
	if ( sServiceName == null )
	{
		_error ( "Constructor : 'ServiceName' argument is null !" );
	}
	if ( sRootUrl == null )
	{
		_error ( "Constructor : 'RootUrl' argument is null !" );
	}
	if ( fctProcessResponse == null )
	{
		_error ( "Constructor : 'callback function' argument is null !" );
	}

	_trace( "ScreenService( " + sServiceName + ", " + sRootUrl + ", function )") ;
	
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================		
	var _sServiceName = sServiceName ;
	var _fctProcessResponse = fctProcessResponse ;
	var _sRootURL = sRootUrl ;
	var _sServiceURL = sRootUrl + sServiceName + ".svc" ;
	var _oRequester = new AjaxRequester( _sServiceURL ); // The AJAX requester
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _buildQueryString()
	{
		_trace("_buildQueryString() : " + arguments.length + " argument(s)");
		if ( arguments.length == 0 )
		{
			_trace("buildQueryString() : No argument" );
			return null ;
		}
		else
		{
			var s = "" ;
			for ( var i = 0 ; i < arguments.length ; i++ )
			{
				if ( i == 0 )
				{
					s = s + "?" ;
				}
				else
				{
					s = s + "&" ;
				}
				s = s + "p"+(i+1)+"="+arguments[i] ; 
			}
			_trace("buildQueryString() : " + s );
			return s ;	
		}
		return null ;
	}
	//------------------------------------------------------------------------------
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	//------------------------------------------------------------------------------
	this.getURL = function () 
	{
		return _sServiceURL ;
	}		
	//------------------------------------------------------------------------------
	this.getName = function () 
	{
		return _sServiceName ;
	}		
	//------------------------------------------------------------------------------
	this.call = function () 
	{
		_trace("call() : " + arguments.length + " argument(s)");
		try {
			//--- Call _buildQueryString() with the arguments received 
			var sFullURL = _sServiceURL + _buildQueryString.apply(this, arguments); 
			//_oRequester.postSync(sFullURL, null, _fctProcessResponse ); 			
			_oRequester.postAsync(sFullURL, null, _fctProcessResponse );
			//_oRequester.getSync(sFullURL, null, _fctProcessResponse );
			//_oRequester.getAsync(sFullURL, null, _fctProcessResponse );
		}
		catch (ex) {
			_error ( "Exception : " + ex.message );
		}	
	}		
	//------------------------------------------------------------------------------
	this.callWithParams = function (params) 
	{
		_trace("callWithParams() : " + arguments.length + " argument(s)");
		if ( arguments.length < 1 ) 
		{
			alert ( "ERROR : callWithParams() : no arguments !" );
			return;
		}
		//--- Build the Query String 
		var s = "" ;
		for ( p in params )
		{
			if ( s == "" )
			{
				s = "?" ;
			}
			else
			{
				s = s + "&" ;
			}
			s = s + p + "=" + params[p] ; 
		}
		_trace("QueryString = '" + s + "'");

		try {
			//--- Call _buildQueryString() with the arguments received 
			var sFullURL = _sServiceURL + s ; 
			//_oRequester.postSync(sFullURL, null, _fctProcessResponse ); 			
			_oRequester.postAsync(sFullURL, null, _fctProcessResponse );
			//_oRequester.getSync(sFullURL, null, _fctProcessResponse );
			//_oRequester.getAsync(sFullURL, null, _fctProcessResponse );
		}
		catch (ex) {
			_error ( "Exception : " + ex.message );
		}	
	}		
	//------------------------------------------------------------------------------
	this.doGet = function () 
	{
		_trace("doGet() : ");
		try {
			//--- Call _buildQueryString() with the arguments received 
			var sFullURL = _sServiceURL + "?action=get" ; 
			//_oRequester.postSync(sFullURL, null, _fctProcessResponse ); 			
			_oRequester.postAsync(sFullURL, null, _fctProcessResponse );
			//_oRequester.getSync(sFullURL, null, _fctProcessResponse );
			//_oRequester.getAsync(sFullURL, null, _fctProcessResponse );
		}
		catch (ex) {
			_error ( "Exception : " + ex.message );
		}	
	}		
	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// TelosysRequester.js
//------------------------------------------------------------------------------
// Version : 1.0  ( 22/03/2005 )
// Author  : Laurent Gurin 
// Changes : . Creation
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// OBJECT 
//------------------------------------------------------------------------------
function TelosysRequester( sDefaultUrlParam )
{
	//alert ( "TelosysRequester constructor ..." );
	
	//------------------------------------------------------------------------------
	// PRIVATE ATTRIBUTES
	//------------------------------------------------------------------------------
	var _bTrace          = false ;
	var _sDefaultUrl     = null ;
	var _oXMLHTTP        = null ; // THE "XMLHttpRequest" object
	var _sRequestContent = null ; // The last request content
	var _oScreenResponse = null ; // The last response object
	var _fCallback       = null ; // The current callback function for Async calls
	
	if ( sDefaultUrlParam != null )
	{
		_sDefaultUrl = sDefaultUrlParam ;
	}
	
	//--- Instance init 	
    if (window.ActiveXObject) 
	{
    	//--- Internet Explorer
    	_oXMLHTTP = new ActiveXObject("Microsoft.XMLHTTP");
    }
    else if (window.XMLHttpRequest)
    {
    	//--- Mozilla & Safari
    	_oXMLHTTP = new XMLHttpRequest();
    }

	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================

	//------------------------------------------------------------------------------
	// 
	//------------------------------------------------------------------------------
	function trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE : \n\n" + sMsg ) ;
	}
	
	//------------------------------------------------------------------------------
	// Build the response object 
	//------------------------------------------------------------------------------
	function _buildScreenResponse () 
	{
		trace( "Method : _buildScreenResponse() : \n" + _oXMLHTTP.responseText ); // Show the response 
	//	trace( "buildScreenResponse() ");
	//	var sResponse = _oXMLHTTP.responseText ;
	//	trace( "Response : \n " + sResponse ); // Show the response 
		_oScreenResponse = new ScreenResponse(_oXMLHTTP);
		return _oScreenResponse ;
	}
	//------------------------------------------------------------------------------
	// "POST" SYNCHRONE
	//------------------------------------------------------------------------------
	function _asyncCallback() // Called for each state change (1,2,3 & 4)
	{
		trace ("Method : _asyncCallback() / readyState = " + _oXMLHTTP.readyState );
		//--- If new state is "COMPLETE" ...
		if ( _oXMLHTTP.readyState == 4 )
		{
			//--- Build the ScreenResponse object
			var response = _buildScreenResponse();
			//--- Run the callback if it exists
			if ( _fCallback != null )
			{
				trace ("Run callback function" );
				_fCallback(response) ;
			}
		}
	}
	//------------------------------------------------------------------------------
	// Send HttpRequest to the server 
	//------------------------------------------------------------------------------
	function _sendRequest ( sMethod, sURL, bAsync, sContent ) // RET : void 
	{
		if ( sMethod == null )
		{
			alert ( "Error : HTTP Method is null ! " ); 
			return ;
		}
		if ( sURL == null )
		{
			alert ( "Error : URL is null ! " ); 
			return ;
		}
		if ( _oXMLHTTP == null )
    	{
			alert ( "Error : XMLHttpRequest object is null !" );
			return ;
    	}

		_sRequestContent  = sContent ;
		
	    trace( "_sendRequest() : \n" + _sRequestContent ); // Show the request 

		//--- (1) Setup the HTTP Request Method and URL 
	    _oXMLHTTP.open (sMethod, sURL, bAsync);  // false = SYNCHRONE  (true = ASYNCHRONE)	    
	    _oXMLHTTP.setRequestHeader("Content-Type", "text/xml");

		//--- (2) Configure the callback method (if ASYNCHRONE) 
	    if ( bAsync )
	    {
			_oXMLHTTP.onreadystatechange = _asyncCallback ;
		}

		//--- (3) Send the request to the server 
	    _oXMLHTTP.send (sContent); // Send the content (via HTTP)

	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================

	//------------------------------------------------------------------------------
	// Get the Xml String of the request
	//------------------------------------------------------------------------------
	this.getRequest = function() 
	{
		return _sRequestContent ;
	}

	//------------------------------------------------------------------------------
	// Get the Screen Response object
	//------------------------------------------------------------------------------
	this.getResponse = function() 
	{
		return _oScreenResponse ;
	}

	//------------------------------------------------------------------------------
	// "POST" SYNCHRONE
	//------------------------------------------------------------------------------
	this.post = function ( sContent, sUrlParam )
	{
		var sUrl = _sDefaultUrl ;
		if ( sUrlParam != null )
		{
			sUrl = sUrlParam ;
		}
		_sendRequest("POST", sUrl, false, sContent);
		//trace ("post - after sendRequest : readyState = " + _oXMLHTTP.readyState );		
		_buildScreenResponse();
	}
	//------------------------------------------------------------------------------
	// "POST" ASYNCHRONE ( with callback function )
	//------------------------------------------------------------------------------
	this.postAsync = function ( sContent, callbackFunction, sUrlParam )
	{
		var sUrl = _sDefaultUrl ;
		if ( sUrlParam != null )
		{
			sUrl = sUrlParam ;
		}
		if ( callbackFunction == null )
		{
			alert ("ERROR on postAsync() : callback function is NULL !");
		}
		_fCallback = callbackFunction ;
		_sendRequest("POST", sUrl, true, sContent);
	}

	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------

	//------------------------------------------------------------------------------
	// Fonction d'affichage de message de trace
	//------------------------------------------------------------------------------
	this.MsgTrace = function ( sMsg ) 
	{
		if ( this.bTrace ) alert ( "TRACE : \n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	// Fonction d'affichage du contenu de l'arbre XML des donnes changes
	//------------------------------------------------------------------------------
	this.ShowXmlData = function () // RET : Void
	{
		alert ( "XmlData : \n" + this.oXMLData.xml );
	}
	
	//------------------------------------------------------------------------------
	// Envoi d'une requete au serveur 
	// Paramtres :
	//  . URL  solliciter ct serveur
	//  . flux XML  envoyer au serveur ( ou "null" si aucunes donnes  envoyer )
	//  . flag : true  = recharger les donnes XML de l'cran avec le XML reu du serveur
	//           false = les conserver en l'tat 
	//------------------------------------------------------------------------------
	this.GenericXmlRequest = function ( sURL, oXml, bReload ) // RET : boolean 
	{
	    //--- Envoi des donnes XML au serveur
	    var oXMLHTTP = null ;
	    if (window.ActiveXObject) 
		{
	    	//--- I.E.
	    	oXMLHTTP = new ActiveXObject("Microsoft.XMLHTTP");
	    }
	    else if (window.XMLHttpRequest)
	    {
	    	//--- Mozilla
	    	oXMLHTTP = new XMLHttpRequest();
	    }
	    
	    oXMLHTTP.open ("POST", sURL, false);  // false = SYNCHRONE  (true = ASYNCHRONE)
	    this.MsgTrace ( "Requete serveur ...\nURL="+sURL);
	    oXMLHTTP.send (oXml); // Send HTTP ( avec un flux XML ou NULL )

	    //--- Interpretation de la rponse du serveur : Cas d'erreur :
	    if ( oXMLHTTP.responseXML     == null ) return false ;
	    if ( oXMLHTTP.responseXML.xml == null ) return false ;
	    if ( oXMLHTTP.responseXML.xml == ""   ) return false ;
	    
		//--- Cas normal ( pas d'erreur ) ==> rcupration des codes retour et message retour
		this.GetResponseStatus( oXMLHTTP.responseXML );
		
    	//--- Doit-on recharger les donnes XML locales ?
    	if ( bReload == true )
    	{
		   	this.oXMLData.load( oXMLHTTP.responseXML );  // "Reload"
    	}
    	
    	return true ; // OK : fin normale de traitement 
	}
	//------------------------------------------------------------------------------
	// Envoi d'une requete au serveur de type "GET CURRENT VALUES" 
	//------------------------------------------------------------------------------
	this.RequestGetCurrentValues = function ( sUrlBase, iPopupLevel ) // RET : boolean
	{
		if ( arguments.length < 2 ) { alert("fonction RequestGetCurrentValues : Paramtre(s) incorrect(s)");return false;} 
		var sUrl = sUrlBase + "?action=GETCURVAL" + this.UrlPopupLevel(iPopupLevel) ;
		return  this.GenericXmlRequest ( sUrl, null, true ) ;
	}
	//------------------------------------------------------------------------------
	// Envoi d'une requete au serveur de type "SELECT" 
	//------------------------------------------------------------------------------
	this.RequestSelect = function ( sUrlBase, iPopupLevel ) // RET : boolean
	{
		if ( arguments.length < 2 ) { alert("fonction RequestSelect : Paramtre(s) incorrect(s)");return false;} 
		var sUrl = sUrlBase + "?action=SELECT" + this.UrlPopupLevel(iPopupLevel) + this.ComposeUrlKeyParams() ;
		return  this.GenericXmlRequest ( sUrl, null, true ) ;
	}
	//------------------------------------------------------------------------------
	// Envoi d'une requete au serveur de type "UPDATE" 
	//------------------------------------------------------------------------------
	this.RequestUpdate = function ( sUrlBase, iPopupLevel ) // RET : boolean
	{
		if ( arguments.length < 2 ) { alert("fonction RequestUpdate : Paramtre(s) incorrect(s)");return false;} 
		var sUrl = sUrlBase + "?action=UPDATE" + this.UrlPopupLevel(iPopupLevel) ;
		return  this.GenericXmlRequest ( sUrl, this.oXMLData, true ) ;
	}
	//------------------------------------------------------------------------------
	// Envoi d'une requete au serveur de type "INSERT" 
	//------------------------------------------------------------------------------
	this.RequestInsert = function ( sUrlBase, iPopupLevel ) // RET : boolean
	{
		if ( arguments.length < 2 ) { alert("fonction RequestInsert : Paramtre(s) incorrect(s)");return false;} 
		var sUrl = sUrlBase + "?action=INSERT" + this.UrlPopupLevel(iPopupLevel) ;
		return  this.GenericXmlRequest ( sUrl, this.oXMLData, true ) ;
	}
	//------------------------------------------------------------------------------
	// Envoi d'une requete au serveur de type "DELETE" 
	//------------------------------------------------------------------------------
	this.RequestDelete = function ( sUrlBase, iPopupLevel ) // RET : boolean
	{
		if ( arguments.length < 2 ) { alert("fonction RequestDelete : Paramtre(s) incorrect(s)");return false;} 
		var sUrl = sUrlBase + "?action=DELETE" + this.UrlPopupLevel(iPopupLevel) + this.ComposeUrlKeyParams() ;
		return  this.GenericXmlRequest ( sUrl, null, false ) ;
	}
	//------------------------------------------------------------------------------
	// Envoi d'une requete au serveur de type "PROCEDURE" avec envoi de donnes au serveur (ds flux XML)
	//------------------------------------------------------------------------------
	this.RequestProcedure = function ( sUrlBase, sProcName, iPopupLevel ) // RET : boolean
	{
		if ( arguments.length < 3 ) { alert("fonction RequestProcedure : Paramtre(s) incorrect(s)");return false;} 
		var sUrl = sUrlBase + "?action=PROC&procname=" + sProcName + this.UrlPopupLevel(iPopupLevel) ;
		return  this.GenericXmlRequest ( sUrl, this.oXMLData, true ) ;
	}
	//------------------------------------------------------------------------------
	// Envoi d'une requete au serveur de type "PROCEDURE" sans envoi de donnes au serveur (sans flux XML)
	//------------------------------------------------------------------------------
	this.RequestProcedureWithoutData = function ( sUrlBase, sProcName, iPopupLevel ) // RET : boolean
	{
		if ( arguments.length < 3 ) { alert("fonction RequestProcedureWithoutData : Paramtre(s) incorrect(s)");return false;} 
		var sUrl = sUrlBase + "?action=PROC&procname=" + sProcName + this.UrlPopupLevel(iPopupLevel) ;
		return  this.GenericXmlRequest ( sUrl, null, true ) ;
	}
	
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// fwkScreenActions.js
//------------------------------------------------------------------------------
// Version : 1.0  ( 12/12/2005 )
// Author  : Laurent GUERIN 
// Changes : none (creation)
//------------------------------------------------------------------------------
// Standard screen actions behavior
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenActions( oScreen )
{
	if ( oScreen == null )
	{
		alert ( "ERROR in ScreenActions constructor : no screen parameter !" );
	}
	
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	
	var _bTrace  = false ;
	
	var _oScreen  = oScreen ; 
	
	var _oRequester = new TelosysRequester(); // The AJAX requester
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE ( ScreenActions object ) : \n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	function _error ( sMsg ) 
	{
		alert ( "ERROR in 'ScreenActions' object : \n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	this.getRequest = function ( sAction )
	//function _getRequest ( sAction ) 
	{
		//--- Create a new request 
		var request = new ScreenRequest();
		//--- Init the request 
		request.setScreenName( _oScreen.getScreenName() );
		request.setScreenId  ( _oScreen.getScreenId()   );
		if ( sAction )
		{
			request.setAction(sAction);
		}
		return request ;
	}
	
	//------------------------------------------------------------------------------
	function _sendRequest(req)
	{
		if ( _oRequester == null )
		{
			throw new Error( "ScreenActions._sendRequest() : The AJAX requester is null ! ");
		}
		if ( _oScreen == null )
		{
			throw new Error( "ScreenActions._sendRequest() : The SCREEN object is null ! ");
		}
		
		_oRequester.post(req.getXmlRequest(), _oScreen.getRequestURL() );	
		
		var response = _oRequester.getResponse();
		
		//response.show();
		//--- Is the return code OK ? 
		if ( response.getReturnCode() != "0" )
		{
			//--- Show the error
			_error("RESPONSE ERROR : " 
					+ "\nReturn Code = " + response.getReturnCode() 
					+ "\nReturn Message = " + response.getReturnMessage() );
		}
		return response ;
		//alert( "XML RESPONSE : \n" + sResponse );
	}
	//------------------------------------------------------------------------------
	//function _sendRequestAsync(req, callBack)
	this.sendRequestAsync = function (req, callBack)
	{
		if ( _oRequester == null )
		{
			throw new Error( "ScreenActions._sendRequest() : The AJAX requester is null ! ");
		}
		if ( _oScreen == null )
		{
			throw new Error( "ScreenActions._sendRequest() : The SCREEN object is null ! ");
		}
		
		_oRequester.postAsync(req.getXmlRequest(), callBack, _oScreen.getRequestURL() );	

/*		
		var response = _oRequester.getResponse();
		
		//response.show();
		return response ;
		//alert( "XML RESPONSE : \n" + sResponse );
*/
	}
	
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.getScreen = function () 
	{
		return _oScreen ;
	}
	//------------------------------------------------------------------------------
	this.doOpen = function () 
	{
		_trace("Action : Open");
		var response = null ;
		try {
			//--- Build the request 
			//var request = _getRequest("open") ;
			var request = this.getRequest("open") ;
			//--- Send the request 
			response = _sendRequest(request);
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doClose = function () 
	{
		_trace("Action : Close");
		var response = null ;
		try {
			//--- Build the request 
			//var request = _getRequest("close") ;
			var request = this.getRequest("close") ;
			//--- Send the request 
			response = _sendRequest(request);
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	this.doGet = function ( bUpdateScreen ) 
	{
		_trace("Action : Get");
		var response = null ;
		try {	
			//--- Build the request 
			//var request = _getRequest("get") ;		
			var request = this.getRequest("get") ;		
			//--- Send the request 
			response = _sendRequest(request);
			if ( response.isOK() )
			{
				if ( response.dataVoid() != true ) // Data is not void
				{
					if ( bUpdateScreen == null || bUpdateScreen == true )
					{
						//--- Populate the screen fields with XML data recieved
						_oScreen.XmlToScreen(response);
					}
				}
				/*** OLD
				if ( response.dataVoid() )
				{
					//alert ( "No Data ( void ) !" );
					this.doGet_DataVoid(response);
				}
				else
				{
					//--- Populate the screen fields with XML data recieved
					_oScreen.XmlToScreen(response);
				}	
				***/		
			}
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doSet = function () 
	{
		_trace("Action : Set");
		var response = null ;
		try {	
			//--- Build the request 
			//var request = _getRequest("set") ;
			var request = this.getRequest("set") ;
			
			var sXmlData = _oScreen.ScreenToXml();
			request.setData(sXmlData);
			
			//--- Send the request 
			response = _sendRequest(request);
		}
		catch (ex) {
			_error ( ex.message );
		}			
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doSetAsync = function (callBack) 
	{
		_trace("Action : SetAsync");
		var response = null ;
		try {	
			//--- Build the request 
			//var request = _getRequest("set") ;
			var request = this.getRequest("set") ;
			
			var sXmlData = _oScreen.ScreenToXml();
			request.setData(sXmlData);
			
			//--- Send the request 
			//_sendRequestAsync(request,callBack);
			this.sendRequestAsync(request,callBack);
		}
		catch (ex) {
			alert ( "ERROR: " + ex.message );
		}			
	}	
	//------------------------------------------------------------------------------
	this.doClear = function ( bUpdateScreen ) 
	{
		_trace("Action : Clear");
		var response = null ;
		try {
			//--- Build the request 
			//var request = _getRequest("clear") ;		
			var request = this.getRequest("clear") ;		
			//--- Send the request 
			response = _sendRequest(request);
			if ( response.isOK() )
			{
				if ( bUpdateScreen == null || bUpdateScreen == true )
				{
					//--- Clear the screen
					_oScreen.Clear();
				}
			}
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	this.doLoad = function ( bUpdateScreen ) 
	{
		_trace("Action : Load");
		var response = null ;
		try {
			//--- Build the request 
			//var request = _getRequest("load") ;
			var request = this.getRequest("load") ;

			//--- Call external method to set the request parameters
			this.prepareToLoad(request);
			
			//--- Send the request ( retrieve the response )
			response = _sendRequest(request);
			if ( response.isOK() )
			{
				if ( response.dataNotFound() != true ) // Data Found
				{
					if ( bUpdateScreen == null || bUpdateScreen == true )
					{
						//--- Populate the screen fields with XML data recieved
						_oScreen.XmlToScreen(response);
					}
				}
				/*** OLD
				if ( response.dataNotFound() )
				{
					//alert ( "Data not found !" );
					this.doLoad_DataNotFound(response);
				}
				else
				{
					//--- Populate the screen fields with XML data recieved
					_oScreen.XmlToScreen(response);
				}
				***/
			}
		}
		catch (ex) {
			_error ( ex.message );
		}	
		return response ;
	}
	//------------------------------------------------------------------------------
	// param Action : "save", "insert", "update"
	//------------------------------------------------------------------------------
	this.sendScreenData = function (sAction)
	{
		_trace("sendScreenData : Action = '" + sAction + "'" );
		var response = null ;
		try {	
			//--- Build the request 
			var request = this.getRequest(sAction) ;
			
			//--- Build the XML tree from screen fields 
			var sXmlData = _oScreen.ScreenToXml();
			request.setData(sXmlData);
			
			//--- Send the request ( retrieve the response )
			response = _sendRequest(request);
		}
		catch (ex) {
			_error ( ex.message );
		}		
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doSave = function () 
	{
		_trace("Action : Save");
		return this.sendScreenData("save");
	}
	//------------------------------------------------------------------------------
	this.doInsert = function () 
	{
		_trace("Action : Insert");
		return this.sendScreenData("insert");
	}
	//------------------------------------------------------------------------------
	this.doUpdate = function () 
	{
		_trace("Action : Update");
		return this.sendScreenData("update");
	}
	//------------------------------------------------------------------------------
	this.doDelete = function ( bUpdateScreen ) 
	{
		_trace("Action : Delete");
		var response = null ;
		try {	
			//--- Build the request 
			//var request = _getRequest("delete") ;
			var request = this.getRequest("delete") ;
			
			//--- Call external method to set the request parameters
			this.prepareToDelete(request);
			
			//--- Send the request ( retrieve the response )
			response = _sendRequest(request);
			if ( response.isOK() )
			{
				if ( bUpdateScreen == null || bUpdateScreen == true )
				{
					//--- Clear the screen
					_oScreen.Clear();
				}
			}			
		}
		catch (ex) {
			_error ( ex.message );
		}	
		return response ;
	}
	//------------------------------------------------------------------------------
	this.doExec = function (sProcName, htParameters) 
	{
		_trace("Action : Exec");
		var response = null ;
		if ( sProcName == null )
		{
			_error ( "doExec() : No procedure name (argument is null) " );
		}
		try {	
			//--- Build the request 
			//var request = _getRequest("exec") ;
			var request = this.getRequest("exec") ;
			//--- Set the procedure name 
			request.setProcedure(sProcName);
			//--- Set the parameters
			if ( htParameters != null )
			{
				for ( name in htParameters )
				{
					_trace ( "request.setParameter(" + name + ", " + htParameters[name] + ")" ) ;
					request.setParameter(name, htParameters[name]);
				}
			}
			
			//--- Call external method to set the request parameters
			/*** OLD
			this.beforeExec(request);
			***/

			//--- Send the request ( retrieve the response )
			response = _sendRequest(request);

			/*** OLD
			if ( response.isOK() )
			{
				//--- Call external method ????
				this.afterExec(request,response);
			}
			***/
		}
		catch (ex) {
			_error ( ex.message );
		}	
		return response ;
	}
		
	//------------------------------------------------------------------------------
	// Default external methods
	//------------------------------------------------------------------------------
	this.prepareToLoad = function ( request ) 
	{
		throw new Error( "ScreenActions : Specific method 'prepareToLoad' not implemented ! ");
	}
	//------------------------------------------------------------------------------
	this.prepareToDelete = function ( request ) 
	{
		throw new Error( "ScreenActions : Specific method 'prepareToDelete' not implemented ! ");
	}
	//------------------------------------------------------------------------------
	/*** OLD
	this.doGet_DataVoid = function ( response ) 
	{
		throw new Error( "ScreenActions : Specific method 'doGet_DataVoid' not implemented ! ");
	}
	//------------------------------------------------------------------------------
	this.doLoad_DataNotFound = function ( response ) 
	{
		throw new Error( "ScreenActions : Specific method 'doLoad_DataNotFound' not implemented ! ");
	}
	***/
	//------------------------------------------------------------------------------
	/***
	this.beforeExec = function ( request ) 
	{
		throw new Error( "ScreenActions : Specific method 'beforeExec' not implemented ! ");
	}
	//------------------------------------------------------------------------------
	this.afterExec = function ( request, response ) 
	{
		throw new Error( "ScreenActions : Specific method 'afterExec' not implemented ! ");
	}
	***/
	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
/**
 * Telosys environment object.
 * This object stores the absolute URLs to access the server side with AJAX calls.
 * It provides different kind of objects ( Screen, Service, Actions, ... )
 * @class   : TelosysEnv
 * @author  : Laurent GUERIN
 * @version : 1.0.1 ( May-04 2006 )
 *
 * @param String : Application root URL
 * @param String : Screen Map URL
 * @param String : Screen Context AJAX calls URL
 *
 */
//------------------------------------------------------------------------------
 
//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function TelosysEnv( sRootUrl, sScreenMapUrl, sAjaxUrl )
{
	if ( arguments.length < 3 )
	{
		alert("ERROR : TelosysEnv : constructor : 3 arguments expected ( sRootUrl, sScreenMapUrl, sAjaxUrl ) ! ");
		return null ;
	}
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _bTrace  = false ;
	
	var _sRootUrl      = sRootUrl ;
	var _sScreenMapUrl = sScreenMapUrl ;
	var _sAjaxUrl      = sAjaxUrl ;
	var _keyboard      = Keyboard.getKeyboard(); 
	var _browser       = Browser.getBrowser() ; 
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE : \n\n" + sMsg ) ;
	}
	//------------------------------------------------------------------------------
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	//------------------------------------------------------------------------------
	/**
	 * Return the absolute URL of the WebApp 
	 * @return String : the URL
	 */
	this.getRootUrl = function () 
	{
		return _sRootUrl ;
	}

	//------------------------------------------------------------------------------
	/**
	 * Return the absolute URL for screenmap calls with optional parameters.
	 * This method can be used with 0 or 5 arguments.
	 * @param  String : Screen Map name 
	 * @param  String : Screen Map type ( "html", "xul" )
	 * @param  String : Context id 
	 * @param  String : Context type 
	 * @param  String : Context action ( "open", "use", "none" ) 
	 * @return String : the URL
	 */
	this.getScreenMapUrl = function (sName, sType, sContextId, sContextType, sAction) 
	{
		if ( arguments.length == 0 )
		{
			return _sScreenMapUrl ;
		}
		if ( arguments.length != 5  )
		{
			alert("ERROR : TelosysEnv.getScreenMapUrl() : 0 or 4 arguments expected !");
			return null ;
		}
		//--- Build the ScreenMap URL with parameters ...
		var s = _sScreenMapUrl ;
		var n = 0 ;
        if ( sName != null )
        {
            s = s + ( n < 1 ? "?" : "&" ) + "name=" + sName ;
            n++;
        }        
        if ( sType != null )
        {
            s = s + ( n < 1 ? "?" : "&" ) + "type=" + sType ;
            n++;
        }
        if ( sContextId != null )
        {
            s = s + ( n < 1 ? "?" : "&" ) + "id=" + sContextId ;
            n++;
        }
        /** Not yet supported ...
        if ( sContextType != null )
        {
            s = s + ( n < 1 ? "?" : "&" ) + "xxxx=" + sContextType ;
            n++;
        }
        **/
        if ( sAction != null )
        {
            s = s + ( n < 1 ? "?" : "&" ) + "action=" + sAction ;
            n++;
        }				
		return s ;
	}

	//------------------------------------------------------------------------------
	/**
	 * Return the absolute URL for Screen Context AJAX calls
	 * @return String : the URL
	 */
	this.getAjaxUrl = function () 
	{
		return _sAjaxUrl ;
	}

	//------------------------------------------------------------------------------
	/**
	 * Create and return a new 'Screen' object
	 * @param  String : Screen name
	 * @param  int    : Screen context ID
	 * @return Screen : Screen instance ( or null if error )
	 */
	this.getScreen = function (sScreenName, sContextId) 
	{
		if ( arguments.length < 2 )
		{
			alert("ERROR : TelosysEnv.getScreen() : 2 arguments expected !");
			return null ;
		}
		return new Screen( sScreenName, _sAjaxUrl, sContextId ) ;
	}
	//------------------------------------------------------------------------------
	/**
	 * Create and return a new 'Service' object
	 * @param  String   : Service name
	 * @param  Function : Callback function to call to process the service response
	 * @return Service  : Service instance ( or null if error )
	 */
	this.getService = function ( sServiceName, callbackFunction ) 
	{
		if ( arguments.length < 2 )
		{
			alert("ERROR : TelosysEnv.getService() : 2 arguments expected !");
			return null ;
		}
		return new ScreenService( sServiceName, _sRootUrl, callbackFunction ) ;
	}
	//------------------------------------------------------------------------------
	/**
	 * Create and return a new 'ScreenActions' object
	 * @param  Screen : Screen instance
	 * @return ScreenActions : ScreenActions instance ( or null if error )
	 */
	this.getActions = function ( oScreen ) 
	{
		if ( arguments.length < 1 )
		{
			alert("ERROR : TelosysEnv.getActions() : argument 'screen' expected !");
			return null ;
		}
		return new ScreenActions( oScreen );  ;
	}
	//------------------------------------------------------------------------------
	this.getKeyboard = function () 
	{
		return _keyboard ;
	}
	//------------------------------------------------------------------------------
	this.getBrowser = function () 
	{
		return _browser ;
	}
	//------------------------------------------------------------------------------
	this.toString = function () 
	{
		return "Root URL='" + _sRootUrl + "' - ScreenMap URL='" + _sScreenMapUrl + "' - Ajax URL='" + _sAjaxUrl + "'" ;
	}	
	//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------
//                               T H E      E N D 
//------------------------------------------------------------------------------

//---------------------------------------------------------------------------------
// TabSet.js ( author : Laurent Gurin )
// TabSet object : 
//  - a TabSet is composed of 1 to N tabs
//  - each tab is associated with a TabPannel
//---------------------------------------------------------------------------------
	function TabSet(pannels, color1, color2)
	{
		 //alert ( "TabSet constructor " ) ;
		//--- Build the mapping "tab Id" -> pannel object 
		this.tabSetPannels = new Object() ;
		for ( tabId in pannels )
		{
			//alert ( tabId + " -> " + pannels[tabId] ) ;
			pannelId = pannels[tabId];
			pannel = document.getElementById(pannelId);
			if ( pannel == null ) 
			{
				alert ( "TabSet constructor : pannel " + pannelId + " not found ! " );
				return ;
			}
			else
			{
				this.tabSetPannels[tabId] = pannel ;
			}
		}

		this.currentTabId = null ; // Id de l'onglet actif en cours
		this.currentPage  = null ; // Page active en cours (Pannel = DIV)
		
		this.txtClassNormal   = color1 ; // CSS class for a normak tab (not selected)
		this.txtClassSelected = color2 ; // CSS class for a selected tab
		/*****
		//--- Couleur de fond
		this.bgColorNormal    = color1;
		this.bgColorSelected  = color2;
		//--- Couleur du texte de l'onglet 
		this.txtColorNormal   = null ;
		this.txtColorSelected = null ;
		//--- Font Weight du texte de l'onglet 
		this.txtFontWeightNormal   = null ;
		this.txtFontWeightSelected = null ;
		//--- Font Size du texte de l'onglet 
		this.txtFontSizeNormal     = null ;
		this.txtFontSizeSelected   = null ;
		//--- Font Family du texte de l'onglet 
		this.txtFontFamilyNormal   = null ;
		this.txtFontFamilySelected = null ;
		*****/
		
		this.error = function  ( msg )
		{
			alert ( "ERROR : TabSet : " + msg ) ;
		}
		this.trace = function  ( msg )
		{
			//alert ( "TRACE : TabSet : " + msg ) ;
		}
		
		this.setCurrentTab = function  ( tabId )
		{
			this.currentTabId = tabId ;
		}

		/**
		this.setTextColor = function  ( normal, active )
		{
			this.txtColorNormal   = normal ;
			this.txtColorSelected = active ;
		}
		this.setFontWeight = function  ( normal, active )
		{
			this.txtFontWeightNormal   = normal ;
			this.txtFontWeightSelected = active ;
		}
		this.setFontSize = function  ( normal, active )
		{
			this.txtFontSizeNormal   = normal ;
			this.txtFontSizeSelected = active ;
		}
		this.setFontFamily = function  ( normal, active )
		{
			this.txtFontFamilyNormal   = normal ;
			this.txtFontFamilySelected = active ;
		}
		**/
		this.setActive = function  ( tabId, pannelId )
		{
			if ( tabId == null ) 
			{
				this.error ( "setActive() : tabId is null !" );
				return ;
			}
			/**
			if ( pannelId == null ) 
			{
				this.error ( "setActive() : pannelId is null !" );
				return ;
			}
			**/
			this.trace ( "setActivePage("+tabId+")" );
			var newTab      = null ;
			var newPageName = null ;
			var newPage     = null ;
			//--- Objet TAB
			newTab = document.getElementById(tabId);
			if ( newTab == null ) 
			{
				this.error ( "Tab  "+tabId+" doesn't exist ( check the ID ) ! " );
				return ;
			}
			//--- Pannel associ  l'onglet
			newPannel = this.tabSetPannels[tabId];
			if ( newPannel == null ) 
			{
				this.error  ( "Pannel not found for this tab ( tabId = " + tabId + " ) ! " );
				return ;
			}
			
			//--- Affichage du nouvel onglet courant
			this.showTab ( tabId ) ;
			
			//--- Affichage de la nouvelle page courante 
			this.showPanel ( newPannel ) ;
		}
		
		this.showPanel = function  ( newPage )
		{
		//alert("showPanel " + newPage.id);
			//--- Cacher la page en cours 
			if ( this.currentPage != null )
			{
				this.currentPage.style.visibility = 'hidden' ;
			}
			//--- Changer de page en cours 
			this.currentPage = newPage ;
			//--- Afficher la page en cours 
			if ( this.currentPage != null )
			{
				this.currentPage.style.visibility = 'visible' ;
			}
		}
		this.showTab = function  ( tabId )
		{
			this.trace ( "showTab : Tab id = " + tabId ) ;						
			//--- Neutralise l'onglet en cours 
			if ( this.currentTabId != null )
			{
				//this.setTabBgColor  ( this.currentTabId, this.bgColorNormal ) ;
				//this.setTabTextStyle( this.currentTabId, false ) ;
				this.setTabTextStyle( this.currentTabId+ "_left",  false ) ;
				this.setTabTextStyle( this.currentTabId,           false ) ;
				this.setTabTextStyle( this.currentTabId+ "_right", false ) ;
			}
			//--- Change l'onglet en cours 
			this.currentTabId = tabId ;
			//--- Active l'onglet en cours 
			if ( this.currentTabId != null )
			{
				//this.setTabBgColor  ( this.currentTabId, this.bgColorSelected ) ;
				//this.setTabTextStyle( this.currentTabId, true ) ;
				this.setTabTextStyle( this.currentTabId+ "_left",  true ) ;
				this.setTabTextStyle( this.currentTabId,           true ) ;
				this.setTabTextStyle( this.currentTabId+ "_right", true ) ;
			}
		}
		/***
		this.setTabBgColor = function  ( tabId, color )
		{
			this.trace ( "setTabBgColor : Tab id = " + tabId ) ;
			this.setBgColor(tabId + "_left",  color ) ;
			this.setBgColor(tabId,            color ) ;
			this.setBgColor(tabId + "_right", color ) ;
		}
		
		this.setBgColor = function  ( objId, color )
		{
			this.trace ( "setBgColor ( "+objId+", "+color+")" ) ;
			var obj = document.getElementById(objId);
			if ( obj == null ) 
			{
				this.error  ( " setBgColor : object "+objId+" not found ! " ) ;
			}
			else
			{
				obj.style.background = color ;
			}
		}
		***/

		this.setTabTextStyle = function  ( tabId, bFlag )
		{
			this.trace ( "setTabTextStyle : Tab id = " + tabId ) ;
			/***
			var text = document.getElementById(tabId + "_a"); 
			if ( text == null )
			{
				this.error ( "element <A> not found ! id = " + tabId + "_a" );
			}
			else
			{
				if ( bFlag == true ) // Selected 
				{
					if ( this.txtColorSelected      != null ) text.style.color      = this.txtColorSelected ;					
					if ( this.txtFontWeightSelected != null ) text.style.fontWeight = this.txtFontWeightSelected ;					
					if ( this.txtFontSizeSelected   != null ) text.style.fontSize   = this.txtFontSizeSelected ;					
					if ( this.txtFontFamilySelected != null ) text.style.fontFamily = this.txtFontFamilySelected ;					
				}
				else // Normal 
				{
					if ( this.txtColorNormal      != null )   text.style.color      = this.txtColorNormal ;					
					if ( this.txtFontWeightNormal != null )   text.style.fontWeight = this.txtFontWeightNormal ;					
					if ( this.txtFontSizeNormal   != null )   text.style.fontSize   = this.txtFontSizeNormal ;					
					if ( this.txtFontFamilyNormal != null )   text.style.fontFamily = this.txtFontFamilyNormal ;					
				}
			}
			***/
			var text = document.getElementById(tabId); 
			if ( text == null )
			{
				this.error ( "element <TD> not found for Tab Id = " + tabId );
			}
			else
			{
				if ( bFlag == true ) // Selected 
				{
					text.className = this.txtClassSelected ;
				}
				else // Normal 
				{
					text.className = this.txtClassNormal ;
				}
			}
		}

	}
